/*****************************************************************************
 *
 *	Copyright (C) 1999-2001 SCADA Technology Control Co., Ltd. All rights reserved.
 *
 *	ļϣйصͷļ
 *
 *	m.j.y		2001/12/07
 *
 * 
 * 
 *	$Name:  $
 *
 *	$Revision: 1.2 $
 *
 *	$Date: 2006/08/04 03:37:33 $
 *	
 *	$State: Exp $
 *
 *	$Log: Profile_Hash.cpp,v $
 *	Revision 1.2  2006/08/04 03:37:33  zhuzhenhua
 *	no message
 *	
 *	Revision 1.1.2.1  2006/07/28 07:54:02  zhuzhenhua
 *	no message
 *	
 *	Revision 1.5  2003/07/14 02:22:38  scada
 *	ʹdefļ,ʹSCADA_API.
 *	
 *	Revision 1.4  2003/01/02 03:14:50  scada
 *	trim  substitution line
 *	
 *	Revision 1.3  2002/12/04 07:47:09  scada
 *	for NT
 *	
 *	Revision 1.2  2002/09/24 05:58:34  harold
 *	take acount __OS_SOLARIS__ where __OS__ occur, set errno to 0 before use it
 *	
 *	Revision 1.1.1.1  2002/08/21 07:16:39  harold
 *	temporarily import
 *	
 *	Revision 1.21  2002/06/03 10:06:27  mhorse
 *	AddNode
 *	
 *	Revision 1.20  2002/03/20 03:40:21  harold
 *	no message
 *	
 *	Revision 1.1.1.1  2002/03/15 13:43:21  harold
 *	no message
 *	
 *	Revision 1.1.1.1  2002/03/15 08:17:11  harold
 *	no message
 *	
 *	Revision 1.19  2002/03/06 01:27:52  harold
 *	*** empty log message ***
 *	
 *	Revision 1.18  2002/02/25 07:30:21  harold
 *	no message
 *	
 *	Revision 1.17  2002/01/25 09:11:19  harold
 *	no message
 *	
 *	Revision 1.16  2002/01/23 02:38:06  harold
 *	test_function
 *	
 *	Revision 1.15  2002/01/22 08:51:42  harold
 *	modify2002-01-22-16:46
 *	
 *	Revision 1.14  2002/01/21 06:15:49  harold
 *	޸˺ֵ
 *	
 *	Revision 1.13  2002/01/21 05:55:25  mhorse
 *	޸˺ֵ
 *	
 *	Revision 1.11  2002/01/18 12:57:15  harold
 *	revise errno
 *	
 *	Revision 1.10  1997/03/29 12:48:33  harold
 *	revise bug in read/write/listsec function
 *	
 *	Revision 1.9  2002/01/18 01:09:33  harold
 *	revise bugs in write/close/listsec function
 *	
 *	Revision 1.8  2002/01/09 11:37:11  harold
 *	no message
 *	
 *	
 *	Revision 1.2  2001/12/19 02:19:22  mhorse
 *	2޸
 *	
 *	Revision 1.1.1.1  2001/12/18 06:42:11  mhorse
 *	ӨһΰļдģCVS(2001/12/18)
 *	
 *
 ******************************************************************************/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include  <sys/stat.h>
#ifdef OS_WINDOWS
#include <winsock2.h>
#include <windows.h>
#include <io.h>
#else
//#include <curses.h>
#include <sys/types.h>
//#include <global_errno.h>
//	#include <sys/uswitch.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#endif
#include "Profile_Hash.h"
#include "confrw_errno.h"
//#include "util.h"
#include "common.h"
#include "basefunc.h"

//¼
static SProfileHanleInfo g_pHandleIndex[MAX_PROFILEHANDLE_NUM];

//¼Ƿ񾭹ʼ PGCTRUE-Ѿʼ
static PGCBOOL g_bHandleInit = PGCFALSE;

//עͷ
#define MARK_pgcchar_NUM		2
static pgcchar gs_szMarkpgcchar[MARK_pgcchar_NUM] = {';', '#'};

//нβַΪ\n,\r
//#define LINE_EXCLUDE_0A


// 	    : UpperCase
// ˵	    : СдתΪд
// ֵ˵	: pgcchar -- תַ
// ˵     : cCh -- Դַ
pgcchar* UpperCase(pgcchar *szSource)
{
    pgcchar* pcTemp = szSource, *pcFirst = szSource;
	
    if (pcTemp == NULL)
		return NULL;
	
	while (*pcTemp != '\0')
	{
		if ((*pcTemp >= 'a') && (*pcTemp <= 'z'))
			*pcTemp = (pgcchar)(*pcTemp - ('a' - 'A')) ;
		pcTemp++;
	}
  	
	return pcFirst;
}


/*
*	ϣ
*/
//	ؼ, ͬ
static u32	fnhash_index_of(const void * pKey, u32 hash_size);

//	ؼ
static void * fnhash_key_of(const SItemInCache * pindex);

//	ȽϹؼ
static int fnhash_compare(const void * pKey1, const void * pKey2);



/*
*	֪ʷݿ, Ϊ佨һϣ.
*
*	
*		pindex	--	ָ
*		count	--	pindexĸ, pindex[0] -- pindex[count - 1]Ϊ
*					
*		pphash_of_index	--	pindexָϣ, , 
*							ʱ, ʹøùϣ.
*	
*	ֵ
*		SUCCESS	--	ɹ
*			--	ʧܴ
*		
*/
#define	INDEX_HASH_TABLE_SIZE_FACTOR			20
pgc32 profile_build_hash_index ( SItemInCache * pindex, 
								pgc32 count,
								TChainHash<SItemInCache> ** pphash_of_index )
{
	pgc32 i = 0;
	TChainHash<SItemInCache> * phash_table = NULL;
	
	phash_table = new TChainHash<SItemInCache>(count * INDEX_HASH_TABLE_SIZE_FACTOR,
												fnhash_index_of,
												fnhash_key_of,
												fnhash_compare,
												NULL/*fnhash_create_item*/,
												NULL/*fnhash_free_item*/,
												NULL/*fnhash_copy_item*/,
												NULL/*fnhash_alloc*/,
												NULL/*fnhash_dealloc*/);
	if (phash_table == NULL)
		return ERROR_MEMORY_ALLOC;
	
	for(i = 0; i < count; i++)
		phash_table->insertItem(pindex + i);
	
	*pphash_of_index = phash_table;
	
	return SUCCESS;
}



/*
*	
*
*	
*		pindex_base	--	ϣָ
*		phash_of_index	--	Ĺϣ
*		szSecName	--	ѯĶ
*		szItemName	-	ѯĿ
*
*	ֵ
*		е	--	ɹĲҵָĿ
*		-1	--	ʧ
*/
pgc32 profile_search_sequence ( SItemInCache **pindex_base,
							   TChainHash<SItemInCache> *phash_of_index,
							   const pgcchar *szSecName,
							   const pgcchar *szItemName)
{
	SItemInCache  *p = NULL, index;
	
    memset(&index, 0, sizeof(SItemInCache));
	if (szSecName != NULL)
	{
		//ִдСдת
#ifdef OS_WINDOWS
		lstrcpyn((LPWSTR)index.szSecName, (LPCWSTR)szSecName, MAX_CHAR_LINE);
		//	strupr(index.szSecName);
#else
		strncpy(index.szSecName, szSecName, MAX_CHAR_LINE - 1);
		//  UpperCase(index.szSecName);
#endif
	}
	if (szItemName != NULL)
	{
#ifdef OS_WINDOWS
    	lstrcpyn((LPWSTR)index.szItemName, (LPCWSTR)szItemName, MAX_CHAR_LINE);
	//	strupr(index.szItemName);
#else
	strncpy(index.szItemName, szItemName, MAX_CHAR_LINE - 1);
     // UpperCase(index.szItemName);
#endif
	}
	p = phash_of_index->searchItem((void *)&index);
	if(NULL == p)
		return -1;
	*pindex_base = p;
	return 0;
}




/*
*	ϣ
*/
//	ؼ, ͬ
static u32	fnhash_index_of(const void * pKey, u32 hash_size)
{
	long index = 0;
	u_char *pbString = NULL;
	int iX = 0, iY = 0, i = 0;
	
	SItemInCache * pindex = (SItemInCache *)pKey, sindex;

	memcpy(&sindex, pindex, sizeof(SItemInCache));
	//ִдСдת
#ifndef OS_WINDOWS
	strupr(sindex.szSecName);
	strupr(sindex.szItemName);
#else
	UpperCase(sindex.szSecName);
	UpperCase(sindex.szItemName);
#endif
	
	//ϣת
	pbString = (u_char*)sindex.szSecName;
	for (i = 0; i < MAX_CHAR_LINE; i++)
	{
		iX = iX + pbString[i];
	}
	iX = iX % MAX_SEC_NUM;
	
	pbString = (u_char*)sindex.szItemName;
	for ( i = 0; i < MAX_CHAR_LINE; i++)
	{
		iY = iY + pbString[i];
	}
	iY = iY % MAX_ITEM_NUM;
	
	index = iX * MAX_ITEM_NUM + iY;
	
	return (u32)(index % hash_size);
}



//	ؼ
static void * fnhash_key_of(const SItemInCache * pindex)
{
	return (void *)(pindex);
}



//	ȽϹؼ
static int fnhash_compare(const void * pKey1, const void * pKey2)
{
	SItemInCache * pindex1 = (SItemInCache *)pKey1;
	SItemInCache * pindex2 = (SItemInCache *)pKey2;
	
	if (pKey1 == NULL)
		return 1;
//#ifdef OS_WINDOWS
	if (pKey2 == NULL)
	{
		if (_stricmp(pindex1->szSecName, pindex2->szSecName) == 0)
			return 0;
		else
			return 1;
	}
	else
	{
		if ((_stricmp(pindex1->szSecName, pindex2->szSecName) == 0)
			&& (_stricmp(pindex1->szItemName, pindex2->szItemName) == 0))
			return 0;
		else
			return 1;
	}
/*#else
	if (pKey2 == NULL)
	{
		
		if (strcasecmp(pindex1->szSecName, pindex2->szSecName) == 0)
			return 0;
		else
			return 1;
	}
	else
	{
		if ((strcasecmp(pindex1->szSecName, pindex2->szSecName) == 0)
			&& (strcasecmp(pindex1->szItemName, pindex2->szItemName) == 0))
			return 0;
		else
			return 1;
	}
#endif*/
}




//жĳǷע
PGCBOOL LineIsMark(pgcchar *szLine)
{
	for (pgc32 i = 0; i < MARK_pgcchar_NUM; i++)
		if (*szLine == gs_szMarkpgcchar[i])
			return PGCTRUE;
		return PGCFALSE;
}


//ѰҶβ
pgcchar* FindSecTail(pgcchar *szString)
{
	pgcchar *szStart = NULL, *szTemp = NULL;

	if ((szStart = strchr(szString, '\n')) == NULL)
	{
		return NULL;
	}
	
	while (szStart != NULL)
	{
	   szStart = strchr(szStart, '[');
	   if ((szStart != NULL) && (*(szStart - 1) == '\n'))
          break;
	   if (szStart != NULL) szStart++;
	}

	if (szStart != NULL)
	{
		szTemp = szStart;
		while ((*szTemp != '\n') && (*szTemp != '\0'))
		{
			if (*szTemp == ']')
				return szStart;
			szTemp ++;
		}
	}
	
	return NULL;
}


//ȡ
PGCBOOL DigSecName(const pgcchar *szString, pgcchar *szRevBuffer, pgc32 iBufferLength)
{
	pgcchar *szStart = NULL, *szTemp = NULL;
	PGCBOOL bSecNameExist = PGCFALSE;
	pgc32 iLength = iBufferLength - 1;
	
	if ((szStart = (pgcchar *)strchr((const char*)szString, '[')) != NULL)
	{
		szTemp = szStart;
		while ((*szTemp != '\n') && (*szTemp != '\0'))
		{
			if (*szTemp == ']')
			{
				bSecNameExist = PGCTRUE;
				break;
			}
			szTemp ++;
		}
		
		if (bSecNameExist)
		{
			iLength = (pgc32)(szTemp - szStart) - 1;
			if (iLength >= iBufferLength)
				iLength = iBufferLength - 1;
            for (pgc32 i = 0; i < iLength; i++)
				szRevBuffer[i] = *(szStart + 1 + i);
			szRevBuffer[iLength] = '\0';
			/*			
			#ifndef __unix__
			strupr(szRevBuffer);
			#else
			UpperCase(szRevBuffer);
			#endif
			*/		
			return PGCTRUE;
		}
	}
	return PGCFALSE;
}


//ȡĿĿֵ
PGCBOOL DigItemContent( pgcchar *szString, pgcchar *szItemName, pgcchar *szItemVal, pgc32 iBufferLength)
{
	pgcchar *pcBeval = NULL, *pcTemp = NULL, szTemp[MAX_CHAR_LINE];
	pgc32 iCount = 0, i = 0;
	
	
	if ((pcBeval = strchr(szString, '=')) == NULL)
		return PGCFALSE;
    
	//ȡĿ
	pcTemp = szString;
    while ((pcTemp < pcBeval) && (iCount < (MAX_CHAR_LINE - 1)))
	{
		szTemp[iCount] = *pcTemp;
		pcTemp++;
		iCount++;
	}
	szTemp[iCount] = '\0';
	
	//ɾǰո
	for ( i = 0; i < MAX_CHAR_LINE; i++)
	{
        if (szTemp[i] != ' ')
		{
			for (pgc32 j = i; j < MAX_CHAR_LINE; j++)
			{
				szTemp[j - i] = szTemp[j];
			}// end for
			break;
		}// end if
	}// end for
	
	//ɾո
	for (i = iCount - 1; i >= 0; i--)
	{
        if (szTemp[i] != ' ')
			break;
		szTemp[i] = '\0';
	}// end for
/*#ifndef __unix__
	strupr(szTemp);
#else
	UpperCase(szTemp);
#endif*/
	strcpy(szItemName, szTemp);
	
	//ȡĿֵ
	memset(szTemp, 0, MAX_CHAR_LINE);
#ifdef OS_WINDOWS
	lstrcpyn((LPWSTR)szTemp, (LPCWSTR)pcBeval + 1, MAX_CHAR_LINE);
#else
	strncpy(szTemp ,pcBeval + 1, MAX_CHAR_LINE - 1);
#endif
	//ɾǰո
	for (i = 0; i < MAX_CHAR_LINE; i++)
	{
        if (szTemp[i] != ' ')
		{
			for (pgc32 j = i; j < MAX_CHAR_LINE; j++)
			{
				szTemp[j - i] = szTemp[j];
			}// end for
			break;
		}// end if
	}// end for
	
	//ɾո
	for ( i = (pgc32)strlen(szTemp) - 1 ; i >= 0; i--)
	{
        if (szTemp[i] != ' ')
			break;
		szTemp[i] = '\0';
	}// end for
	strcpy(szItemVal, szTemp);
	
	return PGCTRUE;
}


// 	    : InsertNode
// ˵	    : ָĶĿ
// ֵ˵	: PGCBOOL --
// ˵     : psHead --
// ˵     : iPos --
// ˵     : psCacheEntry --
// ˵     : iSecPos --
PGCBOOL InsertNode(SItemSequence * &psHead, pgc32 iPos, SItemInCache *psCacheEntry, pgc32 iSecPos)
{
	SItemSequence *psTemp = NULL, *psNewNode = NULL, *psPrior = NULL;
	
	if ((psHead == NULL) || (psCacheEntry == NULL))
		return PGCFALSE;
	psNewNode = new SItemSequence[1];
	psNewNode->iPos = iPos;
    psNewNode->NextNode = NULL;
	
	psTemp = psHead;
	while (psTemp != NULL)
	{
		if (psTemp->iPos == iSecPos)
			break;
		psTemp = psTemp->NextNode;
	}
	while (psTemp != NULL)
	{
		psPrior = psTemp;
		psTemp = psTemp->NextNode;
		if ((psTemp == NULL) || psCacheEntry[psTemp->iPos].bIsSecName)
		{
			psPrior->NextNode = psNewNode;
			psNewNode->NextNode = psTemp;
			return PGCTRUE;
		}
	}
	delete []psNewNode;
	return PGCFALSE;
}



// 	    : DisableSec
// ˵	    : ʹָĶμĸĿЧ
// ֵ˵	: PGCBOOL --
// ˵     : psHead --
// ˵     : iSecPos --
// ˵     : psCacheEntry --
PGCBOOL DisableSec(SItemSequence * &psHead, pgc32 iSecPos, SItemInCache *psCacheEntry)
{
	SItemSequence *psTemp = NULL;
	
	if (psHead == NULL) 
		return PGCFALSE;
	
	psTemp = psHead;
	while (psTemp != NULL)
	{
		if (psTemp->iPos == iSecPos)
			break;
		psTemp = psTemp->NextNode;
	}
	while (psTemp != NULL)
	{
		psCacheEntry[psTemp->iPos].valid = PGCFALSE;
		psTemp = psTemp->NextNode;
		if ((psTemp == NULL) || (psCacheEntry[psTemp->iPos].bIsSecName))
		{
			return PGCTRUE;
		}
	}
	return PGCFALSE;
}



//һڵ㵽˳β
PGCBOOL AddNode(SItemSequence * &psHead, SItemSequence * &pCurSeq, pgc32 iPos)
{
	SItemSequence *psNewNode = NULL;
	
	psNewNode = new SItemSequence[1];
	psNewNode->iPos = iPos;
	psNewNode->NextNode = NULL;
	
	if (psHead == NULL)
	{
		psHead = psNewNode;
		pCurSeq = psHead;	
	}
	else
	{
		if (pCurSeq)
		{
		    pCurSeq->NextNode = psNewNode;
		    pCurSeq = psNewNode;
		}
	}
	
	return PGCTRUE;
}


void ReleaseProfileCache(HPROFILE hProfile)
{
	FILE *fstream = NULL;
	TChainHash<SItemInCache> *pHashTable = NULL;
	SItemSequence *pSequence = NULL, *psPrior = NULL;
    SItemInCache *psCacheEntry = NULL;
	SMemoChain *psMemo = NULL, *psMemoPrior = NULL;
	pgc32 iCurItemCount = 0;
	
	fstream = g_pHandleIndex[hProfile].fstream ;
	if (fstream != NULL)
		fclose(fstream);
	
	pHashTable = g_pHandleIndex[hProfile].pHashTable;
	if (pHashTable != NULL)
		delete pHashTable;
	
	pSequence = g_pHandleIndex[hProfile].pSequence;
	//ɾнڵ
	while (pSequence != NULL)
	{
		psPrior = pSequence;
		pSequence = pSequence->NextNode;
		delete []psPrior;
	}
	
	
	iCurItemCount = g_pHandleIndex[hProfile].CurUseItems;
	psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry;
	//ͷעͽڵ
	if (psCacheEntry != NULL)
	{
		for (pgc32 i = 0; i < iCurItemCount; i++)
		{
			psMemo = psCacheEntry[i].memo;
			while (psMemo != NULL)
			{
				psMemoPrior = psMemo;
				psMemo = psMemo->NextNode;
				delete []psMemoPrior->szMemo;
				delete []psMemoPrior;
			}
		}
		free(psCacheEntry);
	}
	
	return;
}


//С
pgcu32 AdjustCache(HPROFILE hCacher, pgc32 iNewItem)
{
	pgc32 iOldSize = g_pHandleIndex[hCacher].CurItemCount, iNewSize = 0;
	pgc32 iOldUse = g_pHandleIndex[hCacher].CurUseItems;
	SItemInCache *pCacheEntry = NULL;
	
	if ((g_pHandleIndex[hCacher].CurUseItems + iNewItem ) >= iOldSize)
	{
		
		iNewSize = iOldSize + RESIZE_ITEM_NUM;
		pCacheEntry = (SItemInCache*)malloc(iNewSize * sizeof(SItemInCache));
		if (pCacheEntry == NULL)
			return ERROR_MEMORY_ALLOC;
		memset(pCacheEntry, 0, iNewSize * sizeof(SItemInCache));
		memmove(pCacheEntry, g_pHandleIndex[hCacher].pCacheEntry, iOldSize * sizeof(SItemInCache));
		free(g_pHandleIndex[hCacher].pCacheEntry);
		g_pHandleIndex[hCacher].CurItemCount = iNewSize;
		g_pHandleIndex[hCacher].pCacheEntry = pCacheEntry;
		
		//ϣ
		g_pHandleIndex[hCacher].pHashTable->detachItems();
		for (pgc32 i = 0; i < iOldUse; i++)
			g_pHandleIndex[hCacher].pHashTable->insertItem(pCacheEntry + i);
		return SUCCESS;
	}
	return ERROR_FAIL;      
}



// 	    : get_file_lastMTime
// ˵	    : ȡļһα޸ĵʱ
// ֵ˵	: void --
// ˵     : pszfname --
// ˵     : pt --
pgc32 get_file_lastMTime(char * pszfname, timeval *pt)
{
	int ret = 0;

	struct stat buf;

	memset((void *)&buf, 0, sizeof(buf));
	
	ret = stat(pszfname, &buf);
	if(-1 == ret)
		return ERROR_FAIL;

    pt->tv_sec = buf.st_mtime;
	pt->tv_usec = 0;
	return SUCCESS;
}



//дļ
pgc32 ReWriteProfile(HPROFILE hProfile)
{
	pgc32 iSize = 0;
	pgcchar *pcFileBuffer = NULL, *pcTemp = NULL;
	pgcchar *pcHead = NULL;
	PGCBOOL bSecExist = PGCFALSE;
	SItemSequence * psSeq =  g_pHandleIndex[hProfile].pSequence ;
	SItemInCache *psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry, *psTemp = NULL;
	SMemoChain *psMemo = NULL;
	FILE *stream = /*g_pHandleIndex[hProfile].fstream*/0;
	iSize = (g_pHandleIndex[hProfile].CurLines + 2) * (MAX_CHAR_LINE + 2);
	
    if (( pcHead = (pgcchar*)malloc(iSize)) != NULL)
	{
		pcFileBuffer = pcHead;
		memset(pcFileBuffer, 0, iSize);
        while (psSeq != NULL)
		{
			psTemp = psCacheEntry + psSeq->iPos;
			if (psTemp->valid)
			{
				//ע
				psMemo = psTemp->memo;
				while (psMemo != NULL)
				{
					//дһע
					pcTemp = psMemo->szMemo;
					while (*pcTemp != '\0')
					{
						*pcFileBuffer = *pcTemp;
						pcFileBuffer++;
						pcTemp++;
					}
#ifdef LINE_EXCLUDE_0A
					*pcFileBuffer = '\n';
					pcFileBuffer += 1;
#else
					*pcFileBuffer = '\r';
					*(pcFileBuffer + 1) = '\n';
					pcFileBuffer += 2;
#endif
					psMemo = psMemo->NextNode;
				}
				
				//Ƕ
				if (psTemp->bIsSecName)
				{
					if (bSecExist)
					{
#ifdef LINE_EXCLUDE_0A
						*pcFileBuffer = '\n';
						pcFileBuffer += 1;
#else
						*pcFileBuffer = '\r';
						*(pcFileBuffer + 1) = '\n';
						pcFileBuffer += 2;
#endif
					}
					else
						bSecExist = PGCTRUE;
					
					*pcFileBuffer = '[';
					pcFileBuffer++;
					pcTemp = psTemp->szSecName;
					while (*pcTemp != '\0')
					{
						*pcFileBuffer = *pcTemp;
						pcFileBuffer++;
						pcTemp++;
					}
					*pcFileBuffer = ']';
#ifdef LINE_EXCLUDE_0A
					*(pcFileBuffer + 1) = '\n';
					pcFileBuffer += 2;
#else
					*(pcFileBuffer + 1) = '\r';
					*(pcFileBuffer + 2) = '\n';
					pcFileBuffer += 3;
#endif
					
				}
				else
				{
					pcTemp = psTemp->szItemName;
					while (*pcTemp != '\0')
					{
						*pcFileBuffer = *pcTemp;
						pcFileBuffer++;
						pcTemp++;
					}
					*pcFileBuffer = '=';
					pcFileBuffer++;
					pcTemp = psTemp->szItemVal;
					while (*pcTemp != '\0')
					{
						*pcFileBuffer = *pcTemp;
						pcFileBuffer++;
						pcTemp++;
					}
#ifdef LINE_EXCLUDE_0A
					*pcFileBuffer = '\n';
					pcFileBuffer += 1;
#else
					*pcFileBuffer = '\r';
					*(pcFileBuffer + 1) = '\n';
					pcFileBuffer += 2;
#endif
				}// end else
			}// end if "valid"
			psSeq = psSeq->NextNode;
		}// end while
		
		//2002/03/05 С++++++++++++++++++++++++++++++++++++++++++++
#if	0
		pgcu32 numwritten = (pgcu32)pcFileBuffer - (pgcu32)pcHead ;
#endif
		pgcu32 numwritten = (pgcu32)(pcFileBuffer - pcHead) ;
		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


#ifdef OS_WINDOWS
		//windows´ļ
		/*if ((stream = fopen(g_pHandleIndex[hProfile].szPathName, "w+b")) == NULL)
		{
			free(pcHead);
			return ERROR_FOPEN;
		}*/
#else
		//unix´ļ
		/*PGCBOOL bOpenOK = PGCFALSE;
		do
		{
			errno = 0;
			if ((stream = fopen(g_pHandleIndex[hProfile].szPathName, "w+b")) != NULL)
			{
				bOpenOK = PGCTRUE;
				break;
			}
		}
		while (errno == EINTR);
		
		if (!bOpenOK)
		{
			free(pcHead);
			return ERROR_FOPEN;
		}*/
		//ghConfig = DSOpenFile("g_pHandleIndex[hProfile].szPathName");

#endif
	
		fseek(stream, 0, SEEK_SET);
		//fwriteдݵļʱַNULL󣬴Ӷʹļ޷λβ
		pgc32 numwritted  = (pgc32)fwrite(pcHead, sizeof( pgcchar ), numwritten , stream );
		free(pcHead);
		fclose(stream);
		//¼޸ļʱ
		get_file_lastMTime(g_pHandleIndex[hProfile].szPathName, &g_pHandleIndex[hProfile].tLastModify);
        if (numwritted != numwritten)
		{
			return ERROR_FWRITE;
		}
		return SUCCESS;

	}// end if
	return ERROR_FAIL;
}


int timeval_compare(timeval * ptv1, timeval * ptv2)
{
	int del_sec = ptv1->tv_sec - ptv2->tv_sec;
	int del_usec = ptv1->tv_usec - ptv2->tv_usec;

	return (del_sec != 0) ? del_sec : del_usec;
}


// 	    : ReCreateCache
// ˵	    : еǰĽ޸ļҪô˺ؽļ
// ֵ˵	: void --
// ˵     : hProfile --
void ReCreateCache(HPROFILE hProfile)
{
  timeval tLastModify, *ptRecModify = NULL;
  pgcchar *szProfileName = g_pHandleIndex[hProfile].szPathName;
  ptRecModify = &g_pHandleIndex[hProfile].tLastModify;
  if (szProfileName == 0) 
	  return;

  if (get_file_lastMTime(szProfileName, &tLastModify) == SUCCESS)
  {
	if (timeval_compare(&tLastModify, ptRecModify) > 0)
	{
		ReleaseProfileCache(hProfile);
		ProcessCreateCache(hProfile);
	}
  }
  return;
}


pgc32 ProcessCreateCache(HPROFILE hProfile)
{
	pgcchar *pcFileBuffer = NULL, *pcTemp = NULL, *pcStart = NULL, *pcEnd = NULL;
	pgcchar *pcNextLine = NULL, *pcTemp1 = NULL ;
	pgcchar szSecName[MAX_CHAR_LINE], CurItemName[MAX_CHAR_LINE], CurItemVal[MAX_CHAR_LINE];
	SItemInCache *psTemp = NULL;
	SMemoChain *psMemoTep = NULL, *psMemo = NULL;
	TChainHash<SItemInCache> * phash_table = NULL;
	PGCBOOL bSecNameExist = PGCFALSE;
	FILE *fstream = NULL;
	long lFileLength = 0;
	SItemInCache *psCacheEntry = NULL, *psCacheTep = NULL;
	pgc32 iCount = 0, iPos = 0, iCurSec = 0, iCurItem = 0, iCurItemCount = 0;
	//iCurLineType:ǰ 0ȷ 1עУ 2 3Ŀݣ4
	pgc32 iCurLineType = 0, iLines = 0, i = 0;
	pgcchar szProfileName[MAX_PATH_NUM];

	memset(szProfileName, 0, MAX_PATH_NUM);
	//ļȫ·
#ifdef OS_WINDOWS
	lstrcpyn((LPWSTR)szProfileName, (LPWSTR)g_pHandleIndex[hProfile].szPathName, MAX_PATH_NUM);
#else
	strncpy(szProfileName, g_pHandleIndex[hProfile].szPathName, MAX_PATH_NUM - 1);
#endif

	memset(&g_pHandleIndex[hProfile], 0, sizeof(SProfileHanleInfo));
//#ifdef OS_WINDOWS
		//windows´ļ
		if ((fstream = fopen(szProfileName, "r+b")) == NULL)
		{
			return ERROR_FOPEN;
		}
/*#else
		//unix´ļ
		PGCBOOL bOpenOK = PGCFALSE;
		do
		{
			errno = 0;
			if ((fstream = fopen(szProfileName, "r+b")) != NULL)
			{
				bOpenOK = PGCTRUE;
				break;
			}
		}
		while (errno == EINTR);
		
		if (!bOpenOK)
			return ERROR_FOPEN;
#endif*/
	
		if (fseek(fstream, 0, SEEK_END) != 0)
		{
			fclose(fstream);
			return 0;
		}
		
		//ȡļ
		lFileLength = ftell(fstream);
		pcTemp = new pgcchar[lFileLength + 1];
		if (pcTemp == NULL)
		{
			fclose(fstream);
			return 0;
		}
		memset(pcTemp, 0, lFileLength + 1);
		if (fseek(fstream, 0, SEEK_SET) != 0)
		{
			fclose(fstream);
			return 0;
		}
		//ļ뻺
		if ((iCount = (pgc32)fread(pcTemp, sizeof( pgcchar ), lFileLength, fstream)) != lFileLength)
		{
			fclose(fstream);
			return ERROR_FREAD;
		}
		
		
		
		//ʽȥÿһǰĶո
		pcStart = pcTemp;
		pcEnd = pcTemp + iCount;
		while ((pcStart != NULL) && (pcStart < pcEnd))
		{
			if (*pcStart == ' ')
			{
				*pcStart = 0;
				pcStart ++;
			} 
			else
			{
				if (*pcStart == '\n') 
					pcStart ++;
				else
				{
					if ((pcStart = strchr(pcStart, '\n')) == NULL) break;
					pcStart ++;
				}
			}
		}// end while
		
		
		
		//ʽȥÿһн־"\r\n"е"\r"־,"\n"־
		pcStart = pcTemp;
		while ((pcStart != NULL) && (pcStart < pcEnd))
		{
			if ((*pcStart == '\r') && (*(pcStart + 1) == '\n'))
			{
				*pcStart = 0;
				pcStart +=2;
			}
			else
				pcStart++;
		}// end while
		
		
		
		//ͳ
		pcStart = pcTemp;
		while ((pcStart != NULL) && (pcStart < pcEnd))
		{
			if (*pcStart == '\n')
			{
				iLines++;
			}
			pcStart++;
		}// end while
		iLines++;
		g_pHandleIndex[hProfile].CurLines = iLines;
		
		//ؽļ
		pcFileBuffer = new pgcchar[iCount + 1];
		memset(pcFileBuffer, 0, iCount + 1);
		for ( i = 0; i < iCount; i++)
		{
			if (pcTemp[i] != 0)
			{
				pcFileBuffer[iPos] = pcTemp[i];
				iPos++;
			}
		}
		delete []pcTemp;
		
		
		
		//
		psCacheEntry = (SItemInCache *)malloc(INITCACHE_ITEM_NUM * sizeof(SItemInCache));
		if (psCacheEntry == NULL)
		{
			if (pcFileBuffer != NULL)
				delete []pcFileBuffer;
			fclose(fstream);
			return ERROR_MEMORY_ALLOC;
		}
		memset(psCacheEntry, 0, INITCACHE_ITEM_NUM * sizeof(SItemInCache));
		iCurItemCount = INITCACHE_ITEM_NUM;
		g_pHandleIndex[hProfile].fstream = fstream;
		g_pHandleIndex[hProfile].pHashTable = NULL;
		g_pHandleIndex[hProfile].pSequence = NULL;
		g_pHandleIndex[hProfile].pCurSeq = NULL;
		g_pHandleIndex[hProfile].CurItemCount = iCurItemCount;
		g_pHandleIndex[hProfile].pCacheEntry = psCacheEntry;
		
		//ȡ
		pcStart = pcFileBuffer;
		pcEnd = NULL;
		while ((pcStart != NULL) && (pcStart < (pcFileBuffer + iPos)))
		{
			//ѰҶβ
			pcEnd = FindSecTail(pcStart + 1);
			
			if (pcEnd != NULL)
				*(pcEnd - 1) = '\0';
			
			//
			while (pcStart != NULL)
			{
				//ȷһеλ
				if ((pcNextLine = strchr(pcStart, '\n')) != NULL)
				{
					//Ϊ
					if (pcStart == pcNextLine)
						iCurLineType = 4;
					*pcNextLine = '\0';
					pcNextLine++;
				}
				
				if (iCurLineType != 4)
				{
					//鵱ǰǷΪע
					if (LineIsMark(pcStart))
					{
						iCurLineType = 1;
					}
					else
					{
						pcTemp = strchr(pcStart, '[');
						pcTemp1 = strchr(pcStart, ']');
						//ǰǶȡ
						if ( pcTemp && pcTemp1 && (pcTemp1 > pcTemp))
						{
							DigSecName(pcStart, szSecName, MAX_CHAR_LINE);
							iCurLineType = 2;
						}
						else
						{
							pcTemp = strchr(pcStart, '=');
							//ǰĿ¼ȡĿĿֵ
							if (pcTemp != NULL)
							{
								DigItemContent(pcStart, CurItemName, CurItemVal, MAX_CHAR_LINE);
								iCurLineType = 3;
							}
							else
								iCurLineType = 0;
						}
					}// end else
				}
				
				switch (iCurLineType)
				{
					//ע,
				case 1:
				case 4:
					//עڵ
					psMemoTep = psMemo;
					if (psMemoTep != NULL)
					{
						while (psMemoTep->NextNode != NULL)
						{
							psMemoTep = psMemoTep->NextNode;
						}// end while
						psMemoTep->NextNode = new SMemoChain[1];
						if (iCurLineType == 1)
						{
							psMemoTep->NextNode->szMemo = new pgcchar[strlen(pcStart) + 1];
							strcpy(psMemoTep->NextNode->szMemo, pcStart);
						}
						else if (iCurLineType == 4)
						{
#ifdef LINE_EXCLUDE_0A
							psMemoTep->NextNode->szMemo = new pgcchar[2];
							psMemoTep->NextNode->szMemo[0] = '\0';
							psMemoTep->NextNode->szMemo[1] = '\0';
#else
							psMemoTep->NextNode->szMemo = new pgcchar[3];
							psMemoTep->NextNode->szMemo[0] = '\0';
							psMemoTep->NextNode->szMemo[1] = '\n';
							psMemoTep->NextNode->szMemo[2] = '\0';
#endif
						}
						psMemoTep->NextNode->NextNode = NULL;
					}// end if
					else
					{
						psMemo = new SMemoChain[1];
						if (iCurLineType == 1)
						{
							psMemo->szMemo = new pgcchar[strlen(pcStart) + 1];
							strcpy(psMemo->szMemo, pcStart);
						}
						else if (iCurLineType == 4)
						{
#ifdef LINE_EXCLUDE_0A
							psMemo->szMemo = new pgcchar[2];
							psMemo->szMemo[0] = '\0';
							psMemo->szMemo[1] = '\0';
#else
							psMemo->szMemo = new pgcchar[3];
							psMemo->szMemo[0] = '\0';
							psMemo->szMemo[1] = '\n';
							psMemo->szMemo[2] = '\0';
#endif
						}
						psMemo->NextNode = NULL;
					}// end else
					
					break;
					
					//Ƕ
				case 2:
					psTemp = &psCacheEntry[iCurItem];
					strcpy(psTemp->szSecName, szSecName);
					psTemp->valid = PGCTRUE;
					psTemp->bIsSecName = PGCTRUE;
					psTemp->memo = psMemo;
					
					AddNode(g_pHandleIndex[hProfile].pSequence, g_pHandleIndex[hProfile].pCurSeq, iCurItem);
					bSecNameExist = PGCTRUE;
					iCurItem ++; 
					psMemo = NULL;
					break;
					//Ŀֵ
				case 3:
					if (bSecNameExist)
					{
						psTemp = &psCacheEntry[iCurItem];
						strcpy(psTemp->szSecName, szSecName);
						strcpy(psTemp->szItemName, CurItemName);
						strcpy(psTemp->szItemVal, CurItemVal);
						psTemp->valid = PGCTRUE;
						psTemp->bIsSecName = PGCFALSE;
						psTemp->memo = psMemo;
						
						AddNode(g_pHandleIndex[hProfile].pSequence, g_pHandleIndex[hProfile].pCurSeq, iCurItem);
						iCurItem ++; 
						psMemo = NULL;
					}//end if
					break;
					//default:
				}// end switch
				
				iCurLineType = 0;

				//ԭȵĻ̫С
				if (iCurItem >= iCurItemCount) 
				{
					psCacheTep = (SItemInCache*)malloc((iCurItemCount + RESIZE_ITEM_NUM) * sizeof(SItemInCache));
					if (psCacheTep == NULL)
					{
						ReleaseProfileCache(hProfile);
						return ERROR_MEMORY_ALLOC;
					}
					memset(psCacheTep, 0, (iCurItemCount + RESIZE_ITEM_NUM) * sizeof(SItemInCache));
					memmove(psCacheTep, psCacheEntry, sizeof(SItemInCache) * iCurItemCount);
					free(psCacheEntry);
					psCacheEntry = psCacheTep;
					iCurItemCount = iCurItemCount + RESIZE_ITEM_NUM;
					g_pHandleIndex[hProfile].CurItemCount = iCurItemCount;
					g_pHandleIndex[hProfile].pCacheEntry = psCacheEntry;
				}// end if
				
				pcStart = pcNextLine;
	  }// end while
	  bSecNameExist = PGCFALSE;
	  pcStart = pcEnd;
  }// end while
  
  if (pcFileBuffer != NULL)
	  delete []pcFileBuffer;
  
  pgc32 iRev = -1;
  
  //ϣ
  iRev = profile_build_hash_index(psCacheEntry, iCurItem , &phash_table);
  if (iRev != SUCCESS)
  {
	  ReleaseProfileCache(hProfile);
	  return  ERROR_CONF_CREATEHASH ;
  }
  
  g_pHandleIndex[hProfile].pHashTable = phash_table;
  g_pHandleIndex[hProfile].CurUseItems = iCurItem ;
  g_pHandleIndex[hProfile].CurSecNum = iCurSec;
  
  fstream =	g_pHandleIndex[hProfile].fstream;
  g_pHandleIndex[hProfile].fstream = 0;
  fclose(fstream);
  	//ļȫ·
#ifdef OS_WINDOWS
	lstrcpyn((LPWSTR)g_pHandleIndex[hProfile].szPathName, (LPCWSTR)szProfileName, MAX_PATH_NUM);
#else
	strncpy(g_pHandleIndex[hProfile].szPathName, szProfileName, MAX_PATH_NUM - 1);
#endif
  //¼޸ļʱ
  get_file_lastMTime(szProfileName, &g_pHandleIndex[hProfile].tLastModify);

  return SUCCESS;
}





//ΪӦýӿ
//-----------------------------------------------------------------------------------------

// 	    : create_profile_cache
// ˵	    : ļ
// ֵ˵	: HPROFILE -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ

//             ֵ                               ˵
//			   SUCCESS						ɹļ
//		ERROR_CONF_NOHANDLE		ļʧܣԭûпеļǰļ
//			ERROR_FOPEN                      ļʧ
//			ERROR_FREAD                      ļʧ
//       ERROR_CONF_CREATEHASH               ϣʧ
//		   ERROR_MEMORY_ALLOC          ָСڴʧ
//      ERROR_CONF_NULL_HANDEPTR       һյľָ

// ˵     : szProfileName --[in] ļȫ·
// ˵     : phfile --[out]ִгɹ򷵻һ
int create_profile_cache(pgcchar *szProfileName, int *phfile)
{
	HPROFILE hCurCacher = 0;

	if (szProfileName == NULL)
		return ERROR_FOPEN ;

	if (phfile == NULL)
		return ERROR_CONF_NULL_HANDEPTR;

	//Ƿ񾭹ʼ
	if (!g_bHandleInit)
	{
		memset(g_pHandleIndex, 0, MAX_PROFILEHANDLE_NUM * sizeof(SProfileHanleInfo));
		g_bHandleInit = PGCTRUE;
	}
	
	//ΪǰѰһо
	for (int i = 1; i < MAX_PROFILEHANDLE_NUM; i++)
		if (g_pHandleIndex[i].pCacheEntry == NULL)
		{
			hCurCacher = i;
			break;
		}
		
		if ( hCurCacher < 1)
		{
			return ERROR_CONF_NOHANDLE;
		}

		//ļȫ·
#ifdef OS_WINDOWS
		lstrcpyn((LPWSTR)g_pHandleIndex[hCurCacher].szPathName, (LPWSTR)szProfileName, MAX_PATH_NUM);
#else
		strncpy(g_pHandleIndex[hCurCacher].szPathName, szProfileName, MAX_PATH_NUM - 1);
#endif
		pgc32 iExeRev = 0;
		if ((iExeRev = ProcessCreateCache(hCurCacher)) != SUCCESS)
			return iExeRev;
 
        *phfile = hCurCacher;
		return SUCCESS;
}



// 	    : CloseProfileHandle
// ˵	    : رļ
// ߼     : ڸļм¼ϢͷԴ
// ֵ˵	: int -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ

//             ֵ                               ˵
//			   SUCCESS						ɹرļ
//		ERROR_CONF_INVALIDHANDLE		˷Ƿļ

// ˵     : hProfile --[in]ļ
int close_profile_handle(HPROFILE hProfile)
{
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;

	ReleaseProfileCache(hProfile);

	memset(&g_pHandleIndex[hProfile], 0, sizeof(SProfileHanleInfo));

	return SUCCESS;
}


// 	    : GetPgcProfileString
// ˵	    : ݶĿȡĿֵ
// ߼     : ͨlpAppName lpKeyNameҪȡĿֵڵĶĿ
//                ָĶμĿڣȡĿֵlpReturnedStringΪ׵ַ
//                Ŀ껺(Ŀ껺ĳָͨpdwSize)ὫȡĿֵ
//                ĳ('\0'ַ)дַָpdwSizeУ ָĶμĿڣִȱʡ
//                lpDefault ַָĿ껺lpReturnedString; Ŀ껺׵ַ
//				  lpReturnedStringΪջĿ껺ĳС1ôὫκַ
//                Ŀ껺壬ԻὫȡĿֵĳ('\0'ַ)д뵽ָpdwSizeָĵַС  
//                    
//								             
// ֵ˵	: int --  ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ

//             ֵ                               ˵
//			 SUCCESS			   ָĶμĿڣȡĿֵlpReturnedStringΪ׵ַ
//								   Ŀ껺УȡĿֵĳСڻĿ껺ĳȣôĿֵ
//		    			           ȫĿ껺УʱSUCCESS

//		 ERROR_CONF_REVBUFFER      ָĶμĿ,ȡĿֵĳȴĿ껺
//					               ĳ, ôȡĿֵضΪĿ껺һĴСȻٿĿ껺
//								   ʱERROR_CONF_REVBUFFER

//
//		 SUCCESS_CONF_DEFCOPY      ָĶμĿڣlpDefaultָ벻ΪգlpDefault
//								   ַָĿ껺lpReturnedStringlpDefaultַָ
//								   ĳȴĿ껺ĳȣôֻlpDefaultʼ [Ŀ껺ĳ  1]
//                                 ַС

//		ERROR_CONF_INVALIDHANDLE   ˷Ƿļ

//			 ERROR_FAIL            ִʧܣδκַĿ껺
 
// ˵     : lpAppName --[in]
// ˵     : lpKeyName --[in]Ŀ
// ˵     : lpDefault --[in] ȡָĿֵʧʱûַдlpReturnedStringĿ껺
// ˵     : lpReturnedString --[out] Ŀ껺ȡĿֵ
// ˵     : pdwSize -- [in][out]ָ򻺳ĳȵָ룬ͬʱڵý󣬽ȡĿַĳ('\0'ַ)дõַ
// ˵     : hProfile --[in] ļ
int get_pgcprofile_string(
							 const pgcchar * lpAppName,        // points to section name
							 const pgcchar * lpKeyName,         // point to key name
							 const pgcchar * lpDefault,         // point to default string
							 pgcchar * lpReturnedString,   // point to destination buffer
							 pgcu32 * pdwSize,               // point to size of destination buffer
							 HPROFILE hProfile     // point to initialization filename
							 )
{
	SItemInCache *psTemp = NULL;
	TChainHash<SItemInCache> *phash_table = NULL;
	pgcu32 dwBuffer = 0, dwCount = 0, dwNeed = 0;
	//bRevBuffer - PGCTRUEʾջ㹻
	PGCBOOL bRevBuffer = PGCTRUE;
	
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;
	
	if ((lpAppName == NULL) || ( lpKeyName == NULL))
		return ERROR_FAIL;

	ReCreateCache(hProfile);

	phash_table = g_pHandleIndex[hProfile].pHashTable;
	if (phash_table == NULL)
		return ERROR_CONF_INVALIDHANDLE;
	
	profile_search_sequence(&psTemp, phash_table, lpAppName, lpKeyName);
	if ((psTemp != NULL) && (psTemp->valid) && (pdwSize != NULL))
	{
		dwBuffer = (pgcu32)strlen(psTemp->szItemVal) + 1;
		dwNeed = dwBuffer;
		if (dwBuffer > *pdwSize)
		{
			dwBuffer = *pdwSize;
			bRevBuffer = PGCFALSE;
		}
		if ((lpReturnedString != NULL) && (dwBuffer > 0))
		{
			for (dwCount = 0; dwCount < dwBuffer - 1; dwCount++)
				lpReturnedString[dwCount] = psTemp->szItemVal[dwCount];
			
			lpReturnedString[dwCount] = '\0';
		}
	}
	else
	{
		//ִȱʡ
		if ((lpDefault != NULL) && (pdwSize != NULL))
		{
			dwBuffer = (pgcu32)strlen(lpDefault) + 1;
			dwNeed = dwBuffer;
			if (dwBuffer > *pdwSize)
			{
				dwBuffer = *pdwSize;
				bRevBuffer = PGCFALSE;
			}
			if ((dwBuffer > 0) && (lpReturnedString != NULL))
			{
				//2002/03/05 С++++++++++++++++++++++++++++++++++++++++++++
#if	0
				for (pgcu32 dwCount = 0; dwCount < dwBuffer - 1; dwCount++)
#endif			
				for (dwCount = 0; dwCount < dwBuffer - 1; dwCount++)
				//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
					lpReturnedString[dwCount] = lpDefault[dwCount];

				lpReturnedString[dwCount] = '\0';
			}
		}
		else
			dwBuffer = 0;
	}
	*pdwSize = dwNeed;

	if (dwBuffer == 0)
		return ERROR_FAIL;
	
	if (!bRevBuffer) 
		return	ERROR_CONF_REVBUFFER;
	
	return SUCCESS;
}



// 	    : WritePgcProfileString
// ˵	    : ݶĿдĿֵ
// ߼     : ͨlpAppName lpKeyNameҪдĿֵڵĶĿ
//                ָĶμĿڣlpStringָԿַβַ
//				  ԸöĿӦĿֵУȻٰļд뵽ļ,
//				  SUCCESS;ָĶμĿڣݲbInsertItemֵǷĶԼ
//                ĿӵļУbInsertItemΪ棬ӸöĿȻдĿֵ
//                SUCCESS; bInsertItemΪ٣ERROR_FAIL

// ֵ˵	: int -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ

//            ֵ                               ˵
//			 SUCCESS			   ָĶμĿڣlpStringָԿַβַ
//								   ԸöĿӦĿֵУȻٰļд뵽ļ,
//					    		   SUCCESS
//         ERROR_FWRITE            дļ
//		ERROR_CONF_INVALIDHANDLE   ˷Ƿļ
// ERROR_CONF_INPUTSTRING_TOOLARGE ĶĿĿֵַȳ
//			 ERROR_FAIL            ִʧܣδκַдļԼļ
 
// ˵     : lpAppName[in] -- 
// ˵     : lpKeyName[in] -- Ŀ
// ˵     : lpString[in] -- Ҫдַ
// ˵     : hProfile[in] -- ļ
// ˵     : bInsertItem[in] -- ָĶĿʱǷӸöλĿPGCTRUE-ӣPGCFALSE-ӣȱʡ
int write_pgcprofile_string(
							   const pgcchar *  lpAppName,  // point to section name
							   const pgcchar *  lpKeyName,  // point to key name
							   const pgcchar *  lpString,   // point to string to add
							   HPROFILE hProfile,     // handle to Profile Cache
							   PGCBOOL bInsertItem       
							   )
{
	SItemInCache *psTemp = NULL, *psCacheEntry = NULL, *psSec = NULL;
	TChainHash<SItemInCache> *phash_table = NULL;
	pgc32 iBuffer = 0, iCurItem = 0, iSecPos = 0, i = 0, iWriteSuccess = 0;
	PGCBOOL bSecExist = PGCFALSE;
	PGCBOOL bTrunc = PGCFALSE ;/*дַǷ񱻽ض*/
	
	//ϷԼ
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;
	
	//ĿϷԼ
	if ((lpAppName == NULL) || ( lpKeyName == NULL))
		return ERROR_FAIL;

	//жַǷ񳬳
	if (strlen(lpAppName) >= MAX_CHAR_LINE) 
		bTrunc = PGCTRUE;
	if (strlen(lpKeyName) >= MAX_CHAR_LINE) 
		bTrunc = PGCTRUE;
	if ( (lpString != NULL) && (strlen(lpString) >= MAX_CHAR_LINE))
		bTrunc = PGCTRUE;
    if (bTrunc)
		return ERROR_CONF_INPUTSTRING_TOOLARGE;

	//ļ޸,ع
	ReCreateCache(hProfile);

	//ϣϷԼ
	phash_table = g_pHandleIndex[hProfile].pHashTable;
	if (phash_table == NULL)
		return ERROR_CONF_INVALIDHANDLE;
	
	psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry;
	
    psTemp = NULL;
	profile_search_sequence(&psTemp, phash_table, lpAppName, lpKeyName);
	if ((psTemp == NULL) && (bInsertItem))
	{
		//öǷѾ
		profile_search_sequence(&psSec, phash_table, lpAppName, NULL);
		if (psSec != NULL)
		{
			pgcu32 a1, a2;

			//2002/03/05 С++++++++++++++++++++++++++++++++++++++++++++
#if	0
			a1 = (pgcu32)psSec - (pgcu32)psCacheEntry;
#endif
			a1 = (pgcu32)(psSec - psCacheEntry);
			//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

			a2 = (pgcu32)sizeof(SItemInCache);
			iSecPos = a1  / a2;
			bSecExist = PGCTRUE;
			psSec->valid = PGCTRUE;
		}
		
		//عС
        AdjustCache(hProfile, 2);
		psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry;
		iCurItem = g_pHandleIndex[hProfile].CurUseItems;
		
		//Ӧò¶
		if (!bSecExist)
		{
			psTemp = &psCacheEntry[iCurItem];
#ifdef OS_WINDOWS
			lstrcpyn((LPWSTR)psTemp->szSecName, (LPCWSTR)lpAppName, MAX_CHAR_LINE);	
#else
			memset(psTemp->szSecName, 0, MAX_CHAR_LINE);
			strncpy(psTemp->szSecName, lpAppName, MAX_CHAR_LINE - 1);
		
#endif	
			psTemp->valid = PGCTRUE;
			psTemp->bIsSecName = PGCTRUE;
			psTemp->memo = NULL;
			
			phash_table->insertItem(psTemp);
			AddNode(g_pHandleIndex[hProfile].pSequence, g_pHandleIndex[hProfile].pCurSeq, iCurItem);
			iSecPos = iCurItem;
			iCurItem++;
			g_pHandleIndex[hProfile].CurLines++;
		}
		//ĿĿֵ
		psTemp = &psCacheEntry[iCurItem];
		
#ifdef OS_WINDOWS
		lstrcpyn((LPWSTR)psTemp->szSecName, (LPCWSTR)lpAppName, MAX_CHAR_LINE);
		lstrcpyn((LPWSTR)psTemp->szItemName, (LPCWSTR)lpKeyName, MAX_CHAR_LINE);
		lstrcpyn((LPWSTR)psTemp->szItemVal, (LPCWSTR)lpString, MAX_CHAR_LINE);
#else
        memset(psTemp, 0, sizeof(SItemInCache));
		strncpy(psTemp->szSecName, lpAppName, MAX_CHAR_LINE - 1);
		strncpy(psTemp->szItemName, lpKeyName, MAX_CHAR_LINE - 1);
		strncpy(psTemp->szItemVal, lpString, MAX_CHAR_LINE - 1);
#endif
		
		psTemp->valid = PGCTRUE;
		psTemp->bIsSecName = PGCFALSE;
		psTemp->memo = NULL;
		
		
		phash_table->insertItem(psTemp);
		InsertNode(g_pHandleIndex[hProfile].pSequence, iCurItem, psCacheEntry, iSecPos);
		iCurItem++;
		
		g_pHandleIndex[hProfile].CurUseItems = iCurItem;
		g_pHandleIndex[hProfile].CurLines++;
		
		iBuffer = (pgc32)strlen(psTemp->szItemVal);
		psTemp = NULL;
		if ((iWriteSuccess = ReWriteProfile(hProfile)) != SUCCESS)
			return iWriteSuccess;
	}
		
	if ((psTemp == NULL) && (!bInsertItem))
		return ERROR_CONF_NOTEXIST;

	//ָεĿ
	if ((psTemp != NULL) && (lpString != NULL))
	{
		if ((psTemp->valid) || (bInsertItem))
		{
			iBuffer = (pgc32)strlen(lpString);
			if (iBuffer >= MAX_CHAR_LINE)
				iBuffer = MAX_CHAR_LINE - 1;
			for (i = 0; i < iBuffer; i++)
				psTemp->szItemVal[i] = lpString[i];
			psTemp->szItemVal[i] = '\0';
			
			psTemp->valid = PGCTRUE;
			if ((iWriteSuccess = ReWriteProfile(hProfile)) != SUCCESS)
				return iWriteSuccess;
		}
	}
	return SUCCESS;
}



// 	    : GetPgcProfileSectionNames
// ˵	    : ȡļж
// ߼     ļлȡĶļгֵȺдpdwSizeָĵַռ䣬
//				  ÿһַΪ־һĽβٶһַ
//				  ΪжĽ־ڴʽΪ 1\02\0......һ\0\0

// ֵ˵	: int -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ
// ˵     : LPTSTR lpszReturnBuffer --[out] д뻺
// ˵     : pgcu32 *pdwSize -- [in][out]д뻺İֽڳ
// ˵     : pgcu32 *nSecNum --[out]ȡĶдõַ
// ˵     : hProfile-- [in] handle to Profile Cache
int get_pgcprofile_secnames(   pgcchar * lpszReturnBuffer,  // address of return buffer
							   pgcu32 * pdwSize,            // size of return buffer
							   pgcu32 *nSecNum,
							   HPROFILE hProfile      //  handle to Profile Cache
							)
{
	pgc32 iCount  =  g_pHandleIndex[hProfile].CurUseItems , iSecNum = 0, i = -1;
	pgcu32 dwWrite = 0, dwSize = 0, dwNeed = 0;
	SItemInCache *psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry;
	pgcchar *szSec = NULL;
	
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;

	ReCreateCache(hProfile);

	if ((pdwSize != NULL) && (*pdwSize > 2))
		dwSize = *pdwSize - 2;
	
	if ((dwSize > 2) && (lpszReturnBuffer != NULL))
	{
		for (i = 0; i < iCount; i++)
		{
			if ((psCacheEntry[i].bIsSecName) && (psCacheEntry[i].valid))
			{
				szSec = psCacheEntry[i].szSecName;
				dwNeed = dwNeed + (pgcu32)strlen(szSec) + 1;
				iSecNum++;
				while ((dwWrite < dwSize ) && (*szSec != '\0'))
				{
					*lpszReturnBuffer = *szSec;
					dwWrite++;
					lpszReturnBuffer++;
					szSec++;
				}	
				*lpszReturnBuffer = '\0';
				lpszReturnBuffer++;
				dwWrite++;
				if (dwWrite >= dwSize)
					break;
			}// endif
		}// end for
		*lpszReturnBuffer = '\0';
	}
	//жַܺԼθ
	for (pgc32 iStart = i + 1; iStart < iCount; iStart++)
	{
		if ((psCacheEntry[iStart].bIsSecName) && (psCacheEntry[iStart].valid))
		{
			iSecNum++;
			szSec = psCacheEntry[iStart].szSecName;
			if (szSec != NULL)
			{
				dwNeed = dwNeed + (pgcu32)strlen(szSec) + 1;
			}
		}
	}
	if (pdwSize)
		*pdwSize = dwNeed;
	if (nSecNum)
		*nSecNum = iSecNum;

	return SUCCESS;
}



// 	    : del_pgcprofile_key
// ˵	    : ɾָĿ
// ߼     ڻɾָĿԼĿϷעͣȻԸǷʽдļ
                
// ֵ˵	: int -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ
// ˵     : lpAppName --[in] 
// ˵     : lpKeyName -- [in]Ŀ
// ˵     : HPROFILE hProfile -[in]ļĻ
int del_pgcprofile_key( const pgcchar * lpAppName,    // point to section name
						  const pgcchar * lpKeyName,     // point to key name
						  HPROFILE hProfile        // point to initialization filename
						  )
{
	SItemInCache *psTemp = NULL;
	TChainHash<SItemInCache> *phash_table = NULL;
	pgc32 iWriteSuccess = 0;
	
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;
	
	if ((lpAppName == NULL) || ( lpKeyName == NULL))
		return ERROR_FAIL;

	ReCreateCache(hProfile);

	phash_table = g_pHandleIndex[hProfile].pHashTable;
	if (phash_table == NULL)
		return ERROR_CONF_INVALIDHANDLE;
	
	profile_search_sequence(&psTemp, phash_table, lpAppName, lpKeyName);
	if (psTemp != NULL)
	{
		psTemp->valid = PGCFALSE;
		if ((iWriteSuccess = ReWriteProfile(hProfile)) != SUCCESS)
			return iWriteSuccess;
		return SUCCESS;
	}
    return ERROR_CONF_NOTEXIST;	
}




// 	    : del_pgcprofile_sec
// ˵	    : ɾָĶ
// ߼     ڻɾָĶΣԼöϷעͣȻԸǷʽдļ
//                ɾһεͬʱöĿĿϷעͣɾ
				  
// ֵ˵	: int -- ɹ򷵻SUCCESS,ʧ򷵻ؾִʧܵĴ
// ˵     : lpAppName --[in] 
// ˵     : HPROFILE hProfile -[in]ļĻ
int del_pgcprofile_sec( const pgcchar * lpAppName,   
						  HPROFILE hProfile       
						  )
{
	SItemInCache *psSec = NULL, *psCacheEntry = NULL;
	TChainHash<SItemInCache> *phash_table = NULL;
	pgc32 iSecPos = 0;
	
	if ((hProfile < 1) || (hProfile >= MAX_PROFILEHANDLE_NUM))
		return ERROR_CONF_INVALIDHANDLE;
	
	if (lpAppName == NULL)
		return ERROR_FAIL;

	psCacheEntry = g_pHandleIndex[hProfile].pCacheEntry;
	if (psCacheEntry == NULL)
		return ERROR_CONF_INVALIDHANDLE;

	ReCreateCache(hProfile);

	phash_table = g_pHandleIndex[hProfile].pHashTable;
	if (phash_table == NULL)
		return ERROR_CONF_INVALIDHANDLE;
	
	profile_search_sequence(&psSec, phash_table, lpAppName, NULL);
	if (psSec != NULL)
	{
		pgcu32 a1, a2;

		//2002/03/05 С++++++++++++++++++++++++++++++++++++++++++++
#if	0
		a1 = (pgcu32)psSec - (pgcu32)psCacheEntry;
#endif
		a1 = (pgcu32)(psSec - psCacheEntry);
		//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		a2 = (pgcu32)sizeof(SItemInCache);
		iSecPos = a1  / a2;
		if (DisableSec(g_pHandleIndex[hProfile].pSequence, iSecPos, psCacheEntry))
		{
			return ReWriteProfile(hProfile);
		}
	}
    return ERROR_CONF_NOTEXIST;		
}

