
#ifndef		__COMM_PORT_H_ICL__
#define		__COMM_PORT_H_ICL__

#include "common.h"

#define		MSGTYPE_BAOHU_BASE		200
#define		MSGTYPE_BAOHU_103CMD	MSGTYPE_BAOHU_BASE+0
#define		MSGTYPE_BAOHU_103DATA	MSGTYPE_BAOHU_BASE+1
#define		MSGTYPE_BAOHU_SCADACMD	MSGTYPE_BAOHU_BASE+2
#define		MSGTYPE_BAOHU_SCADADATA	MSGTYPE_BAOHU_BASE+3

//  config.ini  portconfig.ini Ϣ
u_long GetPrivateProString(const char *section, const char *entry, const char *defaultstr, char *result, int len, char *inifile);
int GetPrivateProInt(const char *section, const char *entry, int idefault, char *inifile);
u_long GetPrivateProString2(const char *section, const char *entry, const char *defaultstr, char *result, int len, HDSFILE hFile);
int GetPrivateProInt2(const char *section, const char *entry, int idefault, HDSFILE hFile);

int PutDataToBuf( DATA_BUF *buf, u_char *msg, int len );
int GetDataFormBuf( DATA_BUF *databuf, u_char *buf, int len, int clrflag );

// 豸ϢоƬ״̬ͶоƬͺƵ
void ReadPortConfigInfo( u_short );
void ReadPortConfigInfoEx(u_short);

void OpenAllPort( void );
void CloseOnePort( int commid );
void CloseAllPort( void );
void PollAllSerialPort( void );
void PollAllNetPort( void );

int SetPntMsg( int port, int point, void *pntmsg, BYTE type, BYTE attr );
int GetPntMsg( int port, int point, void *pntmsg, BYTE type, BYTE attr );
int SetPorvPntMsg( int port, int point, void *pntmsg, BYTE type, BYTE attr );
int GetPorvPntMsg( int port, int point, void *pntmsg, BYTE type );

int	CheckPollCmdBufEmpty( int port );
int PutPollCmdToBuf( int port, int type, WORD wait, char *buf, int len );
void SendCmdFormPollCmdBuf( int port );

// wen 2005.09.08 ָеָ
void ClearAllCmdFromPollCmdBuf(int port);
// wen 2004.10.25 ӿ
void ClearCmdFormPollCmdBuf( int port );
void ClearCmdFormPollCmdBufEx( int port, char *file, int line );
void ClearCmdAllFlag( int port );
int GetCmdFormPollCmdBuf( int port, u_char *buf, int len );
int ReGetCmdFormPollCmdBuf( int port, u_char *buf, int len );

int GetMaxPort();
int GetPortProtocolIdx(char *name);
char *GetPortProtocolName(int Idx);

// wen 2004.11.16 תsoeݵĴ
// ػеsoe
int ProvWriteSoeData( int provport, SOE_DEF *ptrSoe );
int ProvAndDelGetSoeData( int provport, SOE_DEF *ptrSoe );
int ProvHaveSoeData( int provport );

// wen 2005.02.23
void SendDataToPort(int commid, char *buf, int len);

// wen 2005.02.28
void SendYkYtCommand(int commid, char *buf, int len);
BOOL SendYkYtCommand2(int commid, YKYT_PARAM *pParam);
int  FindProvPntFromYkYtPnt(int commid, int ykytpnt, SIO_PARAM_BAOHU_DEF *pBaohuParam);
BOOL ProvPortYkYtIsTimeOut( int commid, PROV_YKYT_DEF *pProvYkYt );
BOOL IsProvYkYtAck(int commid, PROV_YKYT_DEF *pProvYkYt);
BOOL ShmGetDispYkYtFlag();
BOOL ShmGetDispHostLinkFlag();

// wen 2005.04.18 ڴķͷ
void PortMemoryMalloc( int commid, int type, SIO_PARAM_BAOHU_DEF *pBaohuParam );
void PortMemoryMallocEx( int commid, int type, SIO_PARAM_BAOHU_DEF *pBaohuParam );
BOOL PortDataPntInit(int commid, int type, SIO_PARAM_BAOHU_DEF *pBaohuParam);
void PortMemoryFree( int commid, SIO_PARAM_DEF *pGenParam );
void PortWriteDataFree( int commid );

BOOL IsBaoHuPtr( int commid );
BOOL IsExtInfoPtr( int commid );
BOOL IsSerialPtr( int commid );

/*!
	\brief ȡ˿ڴ򿪱ʶ	
	\param commid -- ˿ں
	\param rwflag -- ʶдʶ
	\ֵ retval-- ض˿ڶд״̬
 */
int ShmGetPortFlag(int commid, int rwflag);

// ݴ
/*!
	\brief ͱݵʵʵװ
	\param commid -- ˿ں
	\param rtumsg -- תıָ
	\note
		ָʽʱò103Լʽ
 */
void SendProtectCmdToDev(int commid, RTUMSG *rtumsg);

/*!
	\brief ʵװݱ浽ָ·˿
	\param rtumsg -- תıָ
	\note
		ָʽʱò103Լʽ
 */
void PutBaohuDataToPort(RTUMSG *rtumsg);
void PutBaohuDataToPortEx(int commid, RTUMSG *rtumsg);

/*!
	\brief ݷ͵еscadaprotectԼ˿
	\param rtumsg -- תıָ
 */
void SendDataToAllScadaProtectPort(RTUMSG *rtumsg);

/*!
	\brief ȡָװõıݿ
	\param commid -- ˿ں
	\param iProvAddr -- װתַ˿ͳһŵĵַ
	\param ppBaoHuDB -- 洢װñݵָ(PAI,PDI,PFIX...)
	\retval ظװñ
 */
int	GetBaohuDB(int commid, int iProvAddr, GROUPDEF **ppBaoHuDB);

int GetSioParam(SIO_PARAM_DEF **ppParam);
int GetDevParam(DEV_DEF **ppParam);
int SetCurPort(int PortNo);
int GetCurPortEx();
int SetDispFlag(int iFlag);

// ȡȫֱ
SIO_PARAM_DEF *GetSioParamPtr();
#endif

