/************************************************************************
 *
 *	Copyright (C) 2003-2004
 *	Shenzhen SCADA Control Technology Co., Ltd.
 *	All rights reserved.
 *	
 *	˫
 *
 *	:	2004/01/10
 *
 *	ժWindoes $(DDKPATH)/inc/ntdef.h$(DDKPATH)/inc/ddk/ntddk.h
 *
 *	$Id: list_entry.h,v 1.1.1.1 2006/07/05 07:31:43 jehu Exp $
 *
 ***********************************************************************/

#ifndef	__LIST_ENTRY_H__SKLJFALKJZLJVADFHOPSHVPZIOXJHCVOIPADFDFNXVCQWEDAH
#define	__LIST_ENTRY_H__SKLJFALKJZLJVADFHOPSHVPZIOXJHCVOIPADFDFNXVCQWEDAH

/*!
 *	˫ṹ, ͷԱ.
 */
typedef struct tag_list_entry_t {

   struct tag_list_entry_t * flink;	/*!< ָԪصǰԪ */

   struct tag_list_entry_t * blink;	/*!< ָԪصĺԪ */

}	list_entry_t;

typedef list_entry_t * plist_entry_t;
typedef list_entry_t ** pplist_entry_t;


/*
 *	˫Ĳ̺
 *
 *  +---------------------------+-----------------------------------------------------+
 *  | Initialize_list_head      | ʼͷеlist_entry_tṹ                    |
 *  +---------------------------+-----------------------------------------------------+
 *  | is_list_empty             | жǷΪ                                    |
 *  +---------------------------+-----------------------------------------------------+ 
 *  | remove_head_list          | ˫ͷȡһԪ--ӹϵ|
 *  +---------------------------+-----------------------------------------------------+ 
 *  | remove_tail_list          | ˫βȡһԪ--ӹϵ|
 *  +---------------------------+-----------------------------------------------------+ 
 *  | remove_entry_list         | ˫ȡָԪ--ӹϵ  |
 *  +---------------------------+-----------------------------------------------------+ 
 *  | insert_tail_list          | ʼһԪ                                |
 *  +---------------------------+-----------------------------------------------------+ 
 *  | insert_head_list          | ڽβһԪ                                |
 *  +---------------------------+-----------------------------------------------------+ 
 *  | CONTAINING_RECORD         | Ԫָ뷴ݳԪԪָ        |
 *  +---------------------------+-----------------------------------------------------+ 
 *
 */

/*
 *	Ԫָ뷴ݳԪԪָ
 */
#ifdef CONTAINING_RECORD
#undef CONTAINING_RECORD
#endif
#define CONTAINING_RECORD(_addr, _type, _field)	((_type *)((char *)(_addr) - (char *)(&((_type *)0)->_field)))

/*
 *	ʼ˫
 *
 *	\param plist_head ָͷ
 */
void Initialize_list_head ( list_entry_t * plist_head );

/*
 *	ж˫ǷΪ
 *	
 *	\retval 0    
 *	\retval 0  
 */
int is_list_empty ( list_entry_t * plist_head );

/*
 *	˫ͷȡһԪ--ӹϵ
 */
list_entry_t * remove_head_list ( list_entry_t * plist_head );


/*
 *	˫βȡһԪ--ӹϵ
 */
list_entry_t * remove_tail_list ( list_entry_t * plist_head );

/*
 *	˫ȡƶԪ--ӹϵ
 */
void remove_entry_list ( list_entry_t * pEntry);

/*
 *	һԪشβ뵽˫
 */
void insert_tail_list ( list_entry_t * plist_head, list_entry_t * pEntry );

/*
 *	һԪشͷ뵽˫
 */
void insert_head_list ( list_entry_t * plist_head, list_entry_t * pEntry);

#endif	/* __LIST_ENTRY_H__SKLJFALKJZLJVADFHOPSHVPZIOXJHCVOIPADFDFNXVCQWEDAH */
