/*----------------------------------------------------------
	    ƽ̨޹صINIļд V1.65
	
		      2002.10.3
----------------------------------------------------------*/

#ifndef INI_FILE_H
#define INI_FILE_H

#include "platform_def.h"

#define MAX_LINE_BUF_LENGTH 2048        //л

#define FILE_OPEN_ERROR -1              //ļ򿪴
#define SECTION_NOT_FOUND -2            //ûҵ
#define KEY_NOT_FOUND -3                //ûҵ 

//ߺ
void StrTrimLeft(char* szBuf);
void StrTrimRight(char* szBuf);
void StrTrimAll(char* szBuf);
long GetFileSize(char* lpszFileName);
int  ReadLineFromFile(FILE* IniFile, char* lpszLineBuf, int iLen);     //ָļжȡһ
bool IfBeforeHasRet(FILE* pFile);       //жϵǰļλǰǷǻз

//ļֵָָ(ַ)
int QGetPrivateProfileString(
	const char* lpszSectionName,    //
	const char* lpszKeyName,        //
	const char* lpszDefault,        //ȱʡַ
    char* lpszReturnedString, //ַ
    u_32  nSize,              //ַ
	const char* lpszFileName,       //iniļ
	const char* lpszRemarkInLineStr = (char*)";",       //עͷ
	const char  chContinueLineChar = '\\'        //з
);

//ļֵָָ()
int QGetPrivateProfileInt(
	  const char* lpszSectionName,  //
	const char* lpszKeyName,      //
	  int   nDefault,         //ȱʡֵ
	const char* lpszFileName,     //iniļ
	const char* lpszRemarkInLineStr = (char*)";",     //עͷ
	const char  chContinueLineChar = '\\'      //з
);

//ļдֵָָ(ַ)
int QWritePrivateProfileString(
	const char* lpszSectionName,	  //
	const char* lpszKeyName,	      //
	const char* lpszString,         //Ҫдַ
	const char* lpszFileName        //INIļ
);

#endif
