/*-----------------------------------------------------------------------------
			        platform_def.h	ϵͳض zl 2002.11.5

	        ļкͲϵͳƽ̨صĳ͡꼰ͷļ
-----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------

볣Լ

(1) Windowsϵͳ:    OS_WINDOWS

(2) Unix(ͳ)ϵͳ: OS_UNIX
(3) Linuxϵͳ:      _OS_UNIX_LINUX_
(4) True64ϵͳ:     _OS_UNIX_TRUR64_
(5) Solarisϵͳ:    _OS_UNIX_SOLARIS_

(6) 64λϵͳ:       _OS_64BIT_

(7) Windowsֽ˳:    _OS_WINDOWS_BYTEORDER_
(8) Solarisֽ˳:    _OS_SOLARIS_BYTEORDER_

[˵]

a. 64λϵͳҪУDEC True64, solaris(ʱ32λϵͳ,ͨsizeof
   (long)Ƿ=8ж)

b. windows, linux, true64 Ȳϵͳֽ˳solaris෴,˷ֱWindows
   solarisΪ岻ֽͬ˳

c. Unixϵͳ෱࣬ÿһĲΪunixϵͳÿֶһ
   볣

-----------------------------------------------------------------------------*/

#ifndef PLATFORM_DEF_H
#define PLATFORM_DEF_H

/*------------------------------------ ͷļ --------------------------------*/

#ifdef OS_WINDOWS      //windows
	#include <windows.h>
	#include <dos.h>
	#include <direct.h>
	#include <time.h>
#endif

#ifdef OS_UNIX         //unix
	#include <sys/types.h>
	#include <sys/ipc.h>
	#include <sys/sem.h>
	#include <sys/msg.h>
	#include <sys/shm.h>
	#include <sys/time.h>
	#include <sys/select.h>
	#include <sys/socket.h>
	#include <sys/stat.h>
	#include <arpa/inet.h>       //inetַнṹͳ嶼
	#include <netinet/in.h>
	#include <errno.h>
	// #include <stropts.h>
	#include <stddef.h>
	#include <stdlib.h>
	#include <stdio.h>
	#include <unistd.h>
	#include <fcntl.h>
	#include <signal.h>
	#include <pthread.h>
	#include <string.h>	
//	#include <time.h>
	#include <netdb.h>           //bsd socketgethostbyname()
#endif

/*------------------------------------ ֶ --------------------------------*/

//ȫ滻,Ϊֲʱ޸ĽṹĹ

#ifdef OS_UNIX
	#define SYSTEMTIME   QSYSTEMTIME
	#define GetLocalTime QGetLocalTime
	#define SetLocalTime QSetLocalTime

	#define GetPrivateProfileString   QGetPrivateProfileString
	#define GetPrivateProfileInt      QGetPrivateProfileInt
	#define WritePrivateProfileString QWritePrivateProfileString

	#define closesocket  close           //winsockйرsocketclosesocket(),bsd socketclose()
#define _strdup strdup
#define lstrcpyn	strncpy
#define _getcwd getcwd
#endif

/*-------------------------------- Ͷ ------------------------------------*/

#ifdef OS_UNIX

	typedef unsigned char  BYTE;
	typedef unsigned char  u_char;
	typedef unsigned char  UCHAR;

	typedef unsigned long  DWORD;
	typedef unsigned short WORD;
	typedef unsigned short u_short;
	typedef unsigned short USHORT;

	typedef int            BOOL;
	typedef int            INT;

	typedef unsigned int   u_int;
	typedef unsigned int   UINT;
	typedef unsigned int   SOCKET;       //ΪͨʱWinsock.hȡͶ

	typedef unsigned long  u_long;
	typedef unsigned long  ULONG;   

#endif

#ifdef _OS_64BIT_
	typedef int i_32;                    //̶Ϊ4ֽڵз
    typedef unsigned int u_32;           //̶Ϊ4ֽڵ޷  

	typedef long _int64;                 //Vc64λ_int6464λunix¶Ӧlong(8ֽ), dnp30.cpp 
#else						        
    typedef long i_32;
    typedef unsigned long u_32; 

	#ifdef OS_UNIX
		typedef int64_t _int64;          //Vc64λ_int6432λunix¶Ӧint64_t,sys/types.hж
	#endif
#endif

#ifdef OS_UNIX
	typedef u_32 DWORD;                  //DWORDΪ̶4ֽڵ޷
#endif

/*-----------------------------------  ----------------------------------*/

#ifdef OS_UNIX
	#define TRUE  1
	#define FALSE 0
	#define NULL  0

	#define INVALID_SOCKET  (SOCKET)(~0)      //ΪͨʱWinsock.hȡͶ
	#define SOCKET_ERROR            (-1)    
	#define INADDR_NONE       0xffffffff
#endif

/*------------------------------------ 궨 -----------------------------------*/

#ifdef OS_UNIX
	#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
	#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
	#define LOWORD(l)           ((WORD)(l))
	#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
	#define LOBYTE(w)           ((BYTE)(w))
	#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
	#define max(a,b)            (((a) > (b)) ? (a) : (b))
	#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

/*-------------------------------------------------------------------------------*/


#endif   //PLATFORM_DEF_H
