//***************************************************************
//*    					  scadaprotect.cpp						*
//*	    			      aaawen 2004.10.19						*
//***************************************************************

#ifdef OS_LINUX
#include "baohulib/commport.h"
#include "baohulib/serialport.h"
#else
#include "commport.h"
#include "udpcomm.h"
#include "display.h"
#endif
#include <math.h>
#include "scadaprotect.h"
#include "buban103.h"

extern SIO_PARAM_DEF    SioParam[];
extern FUNCTION_CALL	*FunCallPtr;
extern BYTE				SyncWordEB[];
extern	void			*pvconf_handle;
extern	void			*pvportconf_handle;
extern  void			*pvdataconf_handle;
extern  char			pvDataFileName[256];
extern  char			IniFilePath[256];

const	int	gActiveConst = 3;
const	int	gStatusConst = 10;

/*!
	֯ṹ:·()+װ
*/
const char *gpStrScadaProtectConfigInfo[] =
{ 
	"*******˹ڲԼʼ*******",
	"ģļ=template.csv",	
	"*******˹ڲԼ*******",
	"",	// ־(м䲻ܺиÿַ)
};

//********************************************************************
//*						   ȡú	        			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void ScadaProtectReadConfig(int commid)
{
	int		i, iMaxPort, iDevId;
	char	szSection[128], entry[256];
	char    szPortConfig[256], szTemplate[256];
	PORTSTATUS	sPortStatus;
	SCADAPROTECTPORTPARAM *pPortParam;

#ifdef OS_LINUX
    strcpy(szPortConfig, "portconfig.ini");
#else
    //GetCurrentDirectory(sizeof(szDir), szDir);
	sprintf(szPortConfig, "%s/portconfig.ini", IniFilePath);
#endif

	SioParam[commid].ExtInfo = HEAP_MALLOC(sizeof(SCADAPROTECTPORTPARAM));
	
	if(!SioParam[commid].ExtInfo)
	{
		sprintf(szSection, "WARN(%04d): commid_%02d ExtInfo=malloc(%d) failed.", 
			_getpid(), commid, sizeof(SCADAPROTECTPORTPARAM));
		DebugPrint(szSection);
		return;
	}

	memset(SioParam[commid].ExtInfo, 0, sizeof(SCADAPROTECTPORTPARAM));
	
	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;

	// ֻSioParam[commid].m_psBaoHuǿʱŻе
	pPortParam->m_psBaoHu = SioParam[commid].m_psBaoHu;

	iMaxPort = GetMaxPort();
	pPortParam->m_pPrtPortStatus = (PORTSTATUS *)HEAP_MALLOC(iMaxPort*sizeof(PORTSTATUS));
	//memset((void *)pPortParam->m_pPrtPortStatus, 0, GetMaxPort()*sizeof(PORTSTATUS));
	
	for(i=0; i<iMaxPort; i++)
	{
		sPortStatus.bPortIdle = TRUE;
		sPortStatus.mmid = 0xFFFFFFFF;
		sPortStatus.timeOut = 0;		
		SetProtectPortIdle(i, pPortParam, &sPortStatus);
	}
	
	pPortParam->m_iActiveTimeCnt = 0;
	pPortParam->m_iActiveTimeConst = (gActiveConst*1000)/TIMER_CNT;
	
	pPortParam->m_iStatusTimeCnt = 0;
	pPortParam->m_iStatusTimeConst = (gStatusConst*1000)/TIMER_CNT;

	// 
	sprintf(szSection, "Port%d", commid+1);
	strcpy(entry, "ģļ");
	GetPrivateProString(szSection, entry, "template.csv", pPortParam->m_chArrayTempletFileName,
		sizeof(pPortParam->m_chArrayTempletFileName)-1, szPortConfig);
#ifdef OS_LINUX
	sprintf(szTemplate, "inf/%s", pPortParam->m_chArrayTempletFileName);
#else
	sprintf(szTemplate, "%s/inf/%s", IniFilePath, pPortParam->m_chArrayTempletFileName);
#endif
	InitScadaInfoFromTempletFile(commid, pPortParam, szTemplate, FALSE);

	// wen 2005.06.22 
	// ʼΪ20
	//SingleListInit(&pPortParam->m_sBaoHuData, 20);
	iDevId = commid<<16;
	SingleListInitEx(&pPortParam->m_sBaoHuData, 20, iDevId);
}

//********************************************************************
//*						  ȡ˿ݺ        			         *
//*int commid     : ˿ں                                     *
//*      u_char buf     : Դָ                           *
//*      int len        : Դ                                 *
//********************************************************************
void ScadaProtectRecvData(int commid, u_char *buf, int len)// Լݴ
{
	int				i;
	PROTECTMSGHEAD	sMsgHead;
	SCADAPROTECTPORTPARAM *pPortParam;
#ifdef _DEBUG_MSG_
	char			szbuf[256];
#endif

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}
	
	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;

	for(i=0; i<len; i++)
	{
		switch(pPortParam->m_psBaoHu->m_iRevStatus)
		{
			case 0:
				pPortParam->m_iRecvLen = 0;
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
				pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				if(buf[i] == SyncWordEB[pPortParam->m_psBaoHu->m_iRevStatus])
				{
					pPortParam->m_psBaoHu->m_iRevStatus++;					
				}
				else
				{
					pPortParam->m_psBaoHu->m_iRevStatus = 50;
					// 
					//SioParam[commid].ErrMsgNum++;
				}
				break;
			case 6:
			case 7:
			case 8:
			case 9:  // 
			case 10:
			case 11:
			case 12:
			case 13: // ˿ں
			case 14:
			case 15:
			case 16:
				pPortParam->m_psBaoHu->m_iRevStatus++;
				pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				break;
			case 17: //   (ȼ)
				pPortParam->m_psBaoHu->m_iRevStatus++;
				pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				memcpy((void *)&sMsgHead, pPortParam->m_achRecvBuf+6, sizeof(PROTECTMSGHEAD));
				SequenceNetToHost((char *)&sMsgHead.MsgLen, sizeof(u_32));
				if(sMsgHead.MsgLen == 0)
				{
					ScadaProtectProcessData(commid, pPortParam, TRUE);
#ifndef OS_LINUX
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_achRecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					pPortParam->m_psBaoHu->m_iRevStatus = 0;
				}
				else
				{
					pPortParam->m_psBaoHu->m_iNeedRevLength = sMsgHead.MsgLen;
				}
				break;
			case 18:// ȷ
				pPortParam->m_psBaoHu->m_iNeedRevLength--;
				pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				if(pPortParam->m_psBaoHu->m_iNeedRevLength > 0)
				{
					// wen 2006.04.29 ޸ȱٺͬ
					if(buf[i] == 0x90)
					{
						if(pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen-2] == (char)0xeb)
						{
							pPortParam->m_achRecvBuf[0] = (char)0xEB;
							pPortParam->m_achRecvBuf[1] = (char)0x90;
							pPortParam->m_psBaoHu->m_iRevStatus = 2;
							pPortParam->m_iRecvLen = 2;
						}
					}
					break;
				}

				ScadaProtectProcessData(commid, pPortParam, TRUE);				
#ifndef OS_LINUX
				if((GetCurPort() == commid) && IsRealDataDisp())
				{
					WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
						(BYTE *)pPortParam->m_achRecvBuf, pPortParam->m_iRecvLen);
				}
#endif
				pPortParam->m_psBaoHu->m_iRevStatus = 0;
				//pPortParam->m_iRecvLen = 0;
				break;

			case 19:// 
			default:				
				if(buf[i] == 0xEB)
				{
#ifndef OS_LINUX
					// wen 2004.11.22 ʾ
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_achRecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					ScadaProtectProcessData(commid, pPortParam, FALSE);
					SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
					
					// ״̬1ʼ
					pPortParam->m_achRecvBuf[0] = buf[i];
					pPortParam->m_psBaoHu->m_iRevStatus = 1;
					pPortParam->m_iRecvLen = 1;
				}
				else
				{
					pPortParam->m_achRecvBuf[pPortParam->m_iRecvLen++] = buf[i];
					if(pPortParam->m_iRecvLen > 200)
					{
#ifndef OS_LINUX
						// wen 2004.11.22 ʾ
						if((GetCurPort() == commid) && IsRealDataDisp())
						{
							WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
								(BYTE *)pPortParam->m_achRecvBuf, pPortParam->m_iRecvLen);
						}
#endif
						ScadaProtectProcessData(commid, pPortParam, FALSE);
						SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
						pPortParam->m_iRecvLen = 0;
					}
				}
				break;
		}
	}

#ifdef _DEBUG_MSG_
	sprintf(szbuf, "wen: commid = %d, send=%d, recv=%d, error=%d, lost=%d\n", commid, 
		SioParam[commid].SendCharNum, SioParam[commid].RecvCharNum, 
		SioParam[commid].ErrMsgNum, SioParam[commid].LostSyncCnt);
	DebugPrint(szbuf);
#endif
}

//********************************************************************
//*						  ʱ        			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void ScadaProtectTimer(int commid)
{
	RTUMSG					rtumsg;	
	PORTSTATUS				sPortStatus;
	SCADAPROTECTPORTPARAM	*pPortParam;

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;

	if(PROTOCOL_MASTER == pPortParam->m_psBaoHu->PortType)
	{
		return;
	}

	ReduceTimeOut(pPortParam);

	//1. Ͷֵݣģ
	if(SingleListHaveData(&pPortParam->m_sBaoHuData) > 0)
	{
		// wen 2006.05.11 RTUMSGṹѹб
		//rtumsg.MsgLen = SingleListGetAndDelData(&pPortParam->m_sBaoHuData, rtumsg.MsgData, sizeof(rtumsg.MsgData));
		rtumsg.MsgLen = SingleListGetAndDelData(&pPortParam->m_sBaoHuData, (BYTE *)&rtumsg, sizeof(RTUMSG));
		rtumsg.MsgLen -= sizeof(RTUMSGHEAD);
		if(rtumsg.MsgLen > 0)
		{
			// wen 2006.05.11 ڴ˽æʶ
			if((rtumsg.PortIdx >= 0) && (rtumsg.PortIdx < GetMaxPort()))
			{
				sPortStatus.bPortIdle = TRUE;
				sPortStatus.mmid = 0xFFFFFFFF;
				sPortStatus.timeOut = 0;
				SetProtectPortIdle(rtumsg.PortIdx, pPortParam, &sPortStatus);
			}

			FormatDataAndSend(commid, (PROTECTMSG *)rtumsg.MsgData);
			return;
		}
	}

	//2. soeݣ¼	
	if(ProvHaveSoeData(commid) > 0)
	{
		//printf("scadaprotect have soe data.\n");
		if(MakeSoeDataPacket(commid) == TRUE)
		{
			return;
		}
	}
	
	//3. ʱͨ״̬
	if(pPortParam->m_iActiveTimeConst > 0)
	{
		pPortParam->m_iActiveTimeCnt++;
		if(pPortParam->m_iActiveTimeCnt > pPortParam->m_iActiveTimeConst)
		{
			pPortParam->m_iActiveTimeCnt = 0;
			MakeNetActivePacket(commid);
		}
	}
	if(pPortParam->m_iStatusTimeConst > 0)
	{
		pPortParam->m_iStatusTimeCnt++;
		if(pPortParam->m_iStatusTimeCnt > pPortParam->m_iStatusTimeConst)
		{
			pPortParam->m_iStatusTimeCnt = 0;
			MakeStatusPacket(commid);
		}
	}
	
	
	//Buban103SendCmdFormPollCmdBuf(commid);
}

//********************************************************************
//*						  ңңݴ     			         *
//*int commid     : ˿ں                                     *
//*      u_char buf     : Դָ                           *
//*      int len        : Դ                                 *
//********************************************************************
void ScadaProtectYkYtProcess(int commid, u_char *buf, int len)		// ңң
{
	int				portno, ykytpnt;
	int				iDirect;
	//SCADAPROTECTPORTPARAM *pPortParam;

	// buf[0] --- ˿ں(=commid)
	// buf[1]
	// buf[2]
	// buf[3]
	// buf[4] --- ص
	// buf[5]
	// buf[6]
	// buf[7]
	// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
	//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
	// buf[9] --- ״̬(1=ֵϣ2=ϵ)
	//                    (λΪ1ʱΪУ, 1=غ, 2=ط, 3=ʧ)
	// תңݵУֻҪתĿصţʵʵĶ˿ںӦǸתĶ˿
	// ת㲢ûָתص㣬صתĵһ¡

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	iDirect = buf[9] & 0x80;
	portno = buf[0]+buf[1]*256+buf[2]*65536+buf[3]*16777216;
	ykytpnt = buf[4]+buf[5]*256+buf[6]*65536+buf[7]*16777216;
}

//********************************************************************
//*						  ϵͳ˳ʱԼ   			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void ScadaProtectExit(int commid)
{
	SCADAPROTECTPORTPARAM	*pPortParam;

	if(SioParam[commid].ExtInfo == NULL)
	{
		return;
	}

	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;

	if(pPortParam->m_pPrtPortStatus != NULL)
	{
		HEAP_FREE(pPortParam->m_pPrtPortStatus);
		pPortParam->m_pPrtPortStatus = NULL;
	}
	if(pPortParam->m_psProvDev != NULL)
	{
		HEAP_FREE(pPortParam->m_psProvDev);
		pPortParam->m_psProvDev = NULL;
	}

	SingleListDelData(&pPortParam->m_sBaoHuData);
}

// úת˿·ʵװõı
void ScadaProtectBaoHuCmdProcess(int commid, RTUMSG *rtumsg, BOOL bUpData)
{
	//char					szDbg[128];
	//int						iProvAddr;
	//PROTECTCONTENTHEAD		*ptrProHead;	
	SCADAPROTECTPORTPARAM	*pPortParam;
	
	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;
	// 
	if(MSGTYPE_BAOHU_SCADADATA == rtumsg->MsgType)
	//if(bUpData == TRUE)
	{
		if(pPortParam->m_psProvDev != NULL)
		{
			// wen 2006.05.11 RTUMSGṹѹб
			//SingleListAddData(&pPortParam->m_sBaoHuData, rtumsg->MsgData, rtumsg->MsgLen);
			SingleListAddData(&pPortParam->m_sBaoHuData, (BYTE *)rtumsg, rtumsg->MsgLen+sizeof(RTUMSGHEAD));
		}
		return;
	}
}

int ScadaProtectGetBaohuDataBase(int commid, int iProvAddr, GROUPDEF **ppBaoHuDB)
{
	return 0;
}
/////////////////////////ͨúӿڽ///////////////////////////////

///////////////////////////Ϊúӿ///////////////////////////
BOOL InitScadaInfoFromTempletFile(int commid, SCADAPROTECTPORTPARAM *psPortParam,\
								  char *ptrTemplate, BOOL bMaster)
{
	char		*ptr;
	char		szBuf[512];
	BOOL		bVal;
	HDSFILE		hFile;
	enum Param_Type	ParamType;
	
	if(bMaster == TRUE)
	{
		return FALSE;
	}

	hFile = DSOpenFile(ptrTemplate);
	if(hFile == NULL)
	{
		return FALSE;
	}
	
	ParamType = PARAM_NO;
	while(TRUE)
	{
		ptr = DSfgets(szBuf, sizeof(szBuf), hFile);
		if(!ptr)
		{
			break;
		}

		// test
		//DebugPrint(szBuf);

		if(strstr(ptr, "·") != NULL)
		{
			//·
			ParamType = PARAM_LINK;
		}
		else if(strstr(ptr, "豸") != NULL)
		{
			ParamType = PARAM_DEV;
		}
		else if(PARAM_NO == ParamType)
		{
			continue;
		}

		switch(ParamType)
		{
			case PARAM_LINK:
				bVal = GetProvDevNumFromTemplateFileScada(commid, hFile, psPortParam);
				if(TRUE == bVal)
				{
					if(psPortParam->m_iDevNum > 0)
					{
						// test
						//DebugPrint("malloc provDev.");

						psPortParam->m_psProvDev = (SCADAPROVDEVDEF *)HEAP_MALLOC(psPortParam->m_iDevNum*sizeof(SCADAPROVDEVDEF));
						if(psPortParam->m_psProvDev == NULL)
						{
							psPortParam->m_iDevNum = 0;
						}
						memset((void *)psPortParam->m_psProvDev, 0, psPortParam->m_iDevNum*sizeof(SCADAPROVDEVDEF));
					}
				}
				break;

			case PARAM_DEV:
				bVal = GetProvDevParamFromTemplateFileScada(commid, hFile, psPortParam);
				break;

			default:
				break;
		}
	}

	DSCloseFile(hFile);
	return TRUE;
}

BOOL GetProvDevNumFromTemplateFileScada(int commid, HDSFILE hFile, SCADAPROTECTPORTPARAM *psPortParam)
{
	char	*ptr, *ptrSour, *ptrDest;
	char	szBuf[512];
	int		i, ilen;
	BOOL	bRetVal;

	ptr = DSfgets(szBuf, sizeof(szBuf), hFile);
	
	if(ptr == NULL)
	{
		return FALSE;
	}

	// test
	//DebugPrint(szBuf);

	ptrSour = szBuf;

	if(strstr(ptrSour, "LINK") == NULL)
	{
		return FALSE;
	}

	bRetVal = FALSE;
	for(i=0; i<4; i++)
	{
		if(GetParamItem(ptrSour, &ptrDest) == FALSE)
		{
			bRetVal = FALSE;
			break;
		}
		*ptrDest = 0;
		ilen = strlen(ptrSour);

		switch(i)
		{
			case 0:// ·
				break;
			case 1:// ·ʶ
				break;
			case 2:// ·ַ
				break;
			case 3:// װ
				if(ilen > 0)
				{
					psPortParam->m_iDevNum = atoi(ptrSour);
					bRetVal = TRUE;
				}
				break;
			case 4:// 
				break;
			case 5:// 
				break;
			case 6:// ַƫ
				break;
			case 7:// 
				break;			
			case 8:// дݿվ
				break;
			case 9:// дݿʼ
				break;
			case 10:// ǷжASDU
				break;
			case 11:// ǷŶ
				break;
			case 12:// Ƿδ¼
				break;
			case 13:// һѯ(ɴѭ⴦)
				break;
		}
		ptrSour = ptrDest+1;
	}
	
	return bRetVal;
}

BOOL GetProvDevParamFromTemplateFileScada(int commid, HDSFILE hFile, SCADAPROTECTPORTPARAM *psPortParam)
{
	char	*ptr, *ptrSour, *ptrDest;
	char	szBuf[512];
	int		i, j, ilen, iNum;
	int		iAiNum, iAiStart, iDiStart;
	int		iPiStart, iYkStart, iPntNo;
	BOOL	bRetVal;
	enum Param_Type	ParamType;

	iAiStart = 0;
	iDiStart = 0;
	iPiStart = 0;
	iYkStart = 0;
	iAiNum = 0;
	ParamType = PARAM_NO;
	for(i=0; i<psPortParam->m_iDevNum;)
	{
		ptr = DSfgets(szBuf, sizeof(szBuf), hFile);
		if(ptr == NULL)
		{
			break;
		}

		// test
		//DebugPrint(szBuf);

		if(strstr(ptr, "豸") != NULL)
		{
			i++;
			iAiNum = 0;
			ParamType = PARAM_NO;
			continue;
		}

		if(strstr(ptr, "·") != NULL)
		{
			break;
		}

		ptrSour = ptr;
		for(j=0; j<8; j++)
		{
			if(GetParamItem(ptrSour, &ptrDest) == FALSE)
			{
				bRetVal = FALSE;
				break;
			}
			*ptrDest = 0;
			ilen = strlen(ptrSour);

			switch(j)
			{
				case 0:// 豸
					break;
				case 1:// 豸ͺ
					break;
				case 2:// 豸ַ
					break;
				case 3:// תַ
					if(PARAM_NO != ParamType)
					{
						break;
					}
					if(ilen > 0)
					{
						psPortParam->m_psProvDev[i].m_iProvAddr = atoi(ptrSour);
					}
					break;
				case 4:// ˿ں&״̬վ&״̬
					if(PARAM_NO != ParamType)
					{
						break;
					}
					if(ilen > 0)
					{
						psPortParam->m_psProvDev[i].m_iRealCommid = atoi(ptrSour);
						if(GetParamItemEx(ptrSour, &ptr, "&") == FALSE)
						{
							psPortParam->m_psProvDev[i].m_iStatusStn = 0;
							psPortParam->m_psProvDev[i].m_iStatusPnt = 0;
							break;
						}
						ptrSour = ptr+1;
						if(strlen(ptrSour) > 0)
						{
							psPortParam->m_psProvDev[i].m_iStatusStn = atoi(ptrSour);
							if(GetParamItemEx(ptrSour, &ptr, "&") == FALSE)
							{
								psPortParam->m_psProvDev[i].m_iStatusStn = 0;
								psPortParam->m_psProvDev[i].m_iStatusPnt = 0;
								break;
							}
							ptrSour = ptr+1;
							if(strlen(ptrSour) > 0)
							{
								psPortParam->m_psProvDev[i].m_iStatusPnt = atoi(ptrSour);
							}
						}
					}
					break;
				case 5:// 
					break;
				case 6:// 
					if(ilen > 0)
					{
						iNum = atoi(ptrSour);
					}
					break;
				case 7:// 
					if(iNum <= 0)
					{
						break;
					}
					if(ilen > 0)
					{
						if(strcmp(ptrSour, "YC") == 0)
						{
							ParamType = PARAM_YC;
							iPntNo = 0;
						}
						else if(strcmp(ptrSour, "YX") == 0)
						{
							ParamType = PARAM_YX;
							psPortParam->m_psProvDev[i].m_sYxInfo.m_iPntNum = iNum;
							psPortParam->m_psProvDev[i].m_sYxInfo.m_iStartPntNo = iDiStart;
							psPortParam->m_psProvDev[i].m_sYxInfo.m_iStnNo = 0;
							psPortParam->m_psProvDev[i].m_sYxInfo.m_psDataInfo = NULL;
							iDiStart += iNum;
							iPntNo = 0;
						}
						else if(strcmp(ptrSour, "YM") == 0)
						{
							ParamType = PARAM_YM;
							iPntNo = 0;
						}
						else if(strcmp(ptrSour, "YK") == 0)
						{
							ParamType = PARAM_YK;
							iPntNo = 0;
						}
						else if(strcmp(ptrSour, "SYNCTIME") == 0)
						{
							ParamType = PARAM_SYNCTIME;
							iPntNo = 0;
						}
						else if(strcmp(ptrSour, "ASDU10") == 0)
						{
							ParamType = PARAM_ASDU10;
							iPntNo = 0;
						}
					}
					break;
				default:
					break;
			}
			ptrSour = ptrDest+1;
		}
		
		switch(ParamType)
		{
			case PARAM_YC:
				break;
			case PARAM_YX:
				break;
			case PARAM_YM:
				break;
			case PARAM_YK:
				break;
			case PARAM_SYNCTIME:
				break;
			case PARAM_ASDU10:
				break;
			default:
				break;
		}
	}
	return bRetVal;
}

int FindProtectDevFromPntNoScada(SCADAPROTECTPORTPARAM *psPortParam, int iPntNo, int itype)
{
	int				i, ipnt;
	BOOL			bRetVal;
	DBORIENTATION	*pDataUnit;
	
	bRetVal = FALSE;	
	if(psPortParam->m_psProvDev == NULL)
	{
		return -1;
	}
	
	//printf("psPortParam->m_iDevNum = %d\n", psPortParam->m_iDevNum);

	for(i=0; i<psPortParam->m_iDevNum; i++)
	{
		switch(itype)
		{
			case DI_PNT_TYPE:
				pDataUnit = &psPortParam->m_psProvDev[i].m_sYxInfo;
				break;
			case AI_PNT_TYPE:
			case PI_PNT_TYPE:						
			default:
				pDataUnit = NULL;
				break;
		}
		if(pDataUnit == NULL)
		{
			continue;
		}

		//printf("pDataUnit->m_iStartPntNo=%d, pDataUnit->m_iPntNum=%d\n",
		//	pDataUnit->m_iStartPntNo, pDataUnit->m_iPntNum);

		ipnt = iPntNo - pDataUnit->m_iStartPntNo;
		if((ipnt >= 0) && (ipnt < pDataUnit->m_iPntNum))
		{
			break;
		}
	}

	if(i >= psPortParam->m_iDevNum)
	{
		return -1;
	}
	else
	{
		return i;
	}
}
/////////////////////////////úӿڽ///////////////////////////


void ScadaProtectProvMakeYkYtCommand(int commid, u_char *buf, int len)
{
	// buf[0] --- ˿ں(=commid)
	// buf[1]
	// buf[2]
	// buf[3]
	// buf[4] --- ص
	// buf[5]
	// buf[6]
	// buf[7]
	// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
	//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
	// buf[9] --- ״̬(1=ֵϣ2=ϵ, 0=ʧ)
	//                    (λΪ1ʱΪУ)
	// תңݵУֻҪתĿصţʵʵĶ˿ںӦǸתĶ˿
	// ת㲢ûָתص㣬صתĵһ¡
}

///////////////////////ΪԼӿ///////////////////////////
//*******************************************************************************/
//*			ͻ˵ǰûеıĴֽ˳תֽ˳		*/
//*RTUMSG* hostmsg:תֽ˳								*/
//*		 ORTUMSG* userdata:תǰֽ˳								*/
//*ֵ																	*/
//*******************************************************************************/
void AllNetToHostByteSequence(PROTECTMSG *userdata)
{
	u_32	iOffset; 
	pPROTECTCONTENTHEAD ptrContent;
#ifdef _DEBUG_MSG_
	char			szbuf[256];
#endif

	SequenceNetToHost((char *)&userdata->MsgType, sizeof(u_32));
	SequenceNetToHost((char *)&userdata->PortNumber, sizeof(u_32));
	SequenceNetToHost((char *)&userdata->MsgLen, sizeof(u_32));
	switch(userdata->MsgType)
	{
		case pPFV_PROTECT_BYPASS://ǰû
			ptrContent = (pPROTECTCONTENTHEAD)(userdata->MsgData);
			//תַ
			SequenceNetToHost((char *)&ptrContent->uAddr, sizeof(u_32));
			//ת
			SequenceNetToHost((char *)&ptrContent->uFuncCode, sizeof(u_32));
			//û
			SequenceNetToHost((char *)&ptrContent->ummid, sizeof(u_32));
			//ֽ
			SequenceNetToHost((char *)&ptrContent->uReserved, sizeof(u_32));
			//ֵ
			//ptrContent->cFixNo;
			//CPU 
			//ptrContent->cCPUNo;
			iOffset = sizeof(PROTECTCONTENTHEAD);
			switch(ptrContent->uFuncCode)
			{
				case hREADFIX://ȡֵ
				case hREADPAI:// ȡģ
				case hREADPDI:// ȡ
				case hQUERYFAULT:// ȡָϱ
				case hQUERYSELFCHECK:// ȡָԼ챨					
					break;
				case hREADFIXNO://ȡֵ
				case hREADPWAVE:// ȡ
					break;		
				case hWRITEALLFIX:// ޸ıֵ
					// ʼ
					SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(u_32));
					iOffset += sizeof(u_32);
					for(; iOffset<userdata->MsgLen;)
					{
						// 
						switch(userdata->MsgData[iOffset++] & 0x7F)
						{
							case DATATYPE_AI:
								// ֵ(ռλ)
								iOffset++;
								// ֵ
								SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(float));
								iOffset += sizeof(float);
								break;
							case DATATYPE_DI:
								// ֵ(ռλ)
								iOffset++;
								SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(float));
								iOffset += sizeof(float);
								break;
							case DATATYPE_STRING:
								// ֵ(ռֽ)
								// ֵ
								iOffset += userdata->MsgData[iOffset] + 1;
								break;
							default:
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "·дֵĸʽдЧ");
								DebugPrint(szbuf);
#endif
								userdata->MsgLen = 0;
								return;
						}
					}
					break;
				case hWRITESPECIALFIX:// ޸ָıֵ			
					for(;iOffset<userdata->MsgLen;)
					{
						// ֵ
						SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
						// 
						switch(userdata->MsgData[iOffset++] & 0x7F)
						{
							case DATATYPE_AI:
								// ֵ(ռλ)
								iOffset++;
								// ֵ
								SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(float));
								iOffset += sizeof(float);
								break;
							case DATATYPE_DI:
								// ֵ(ռλ)
								iOffset++;
								SequenceNetToHost((char *)&userdata->MsgData[iOffset], sizeof(float));
								iOffset += sizeof(float);
								break;
							case DATATYPE_STRING:
								// ֵ(ռֽ)
								// ֵ
								iOffset += userdata->MsgData[iOffset] + 1;
								break;
							default:
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "·дֵָĸʽдЧ");
								DebugPrint(szbuf);
#endif
								userdata->MsgLen = 0;
								return;
						}
					}
					break;
				case hWRITEFIXNO:// ޸ıֵ
					break;
				case hRESETPROTECT:// źŸ
					break;
				case hCHECKTIME:// װöʱ
					break;
				case hBROADCASTCHECKTIME:// װù㲥ʱ
					break;
				case hCANCEL:// ȡ
					break;
			}
			break;
		case fPFV_NETACTIVE://԰
			break;
		default:
			break;
	}
}

//*******************************************************************************/
//*			ǰûͻеıĴֽ˳תֽ˳		*/
//*RTUMSG* userdata:תǰֽ˳								*/
//*		 ORTUMSG* hostmsg:תֽ˳								*/
//*ֵ																	*/
//*******************************************************************************/
void AllHostToNetByteSequence(PROTECTMSG *userdata)
{
	u_short u_shortLen;
	u_32  uDataLen, datatype, msgtype, uFuncCode;
	u_32  iOffset;
	pPROTECTCONTENTHEAD ptrContent;
#ifdef _DEBUG_MSG_
	char szbuf[512];
#endif
	
	uDataLen = userdata->MsgLen;
	msgtype = userdata->MsgType;
	SequenceHostToNet((char *)&userdata->MsgType, sizeof(u_32));
	SequenceHostToNet((char *)&userdata->PortNumber, sizeof(u_32));
	SequenceHostToNet((char *)&userdata->MsgLen, sizeof(u_32));
	
	switch(msgtype)
	{
		case fPFV_PROTECT_BYPASS_ACK://ǰû
			ptrContent = (pPROTECTCONTENTHEAD)(userdata->MsgData);
			uFuncCode = ptrContent->uFuncCode;
			//תַ
			SequenceHostToNet((char *)&ptrContent->uAddr, sizeof(u_32));
			//ת
			SequenceHostToNet((char *)&ptrContent->uFuncCode, sizeof(u_32));
			//û
			SequenceHostToNet((char *)&ptrContent->ummid, sizeof(u_32));
			//ֽ
			SequenceHostToNet((char *)&ptrContent->uReserved, sizeof(u_32));
			//ֵ
			//ptrContent->cFixNo;
			//CPU 
			//ptrContent->cCPUNo;
			iOffset = sizeof(PROTECTCONTENTHEAD);
			switch(uFuncCode)
			{
				case hREADINGDATA:// 
					break;
				case hFIXDATAWITHNO:// ֵݴ
					// ֵ
					datatype = userdata->MsgData[iOffset++];

					for(;iOffset<uDataLen;)
					{
						switch(datatype)
						{
							case ITEM_ATTR_REALVALUE:// ʵֵ
							case ITEM_ATTR_DEFAULTVALUE:// ȱʡֵ
							case ITEM_ATTR_MINMAXSTEP://   
							case ITEM_ATTR_PRECISION://   
							case ITEM_ATTR_FIGURE://   
								// 								
								if((iOffset + sizeof(WORD)) < MAX_RTU_MSG_SIZE)
								{
									SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(WORD));
									iOffset += sizeof(WORD);
								}
								else
								{
#ifdef _DEBUG_MSG_
									sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
									DebugPrint(szbuf);
#endif
								}
								// ֵ
								switch(userdata->MsgData[iOffset] & 0x7F)
								{
									case DATATYPE_AI:
									case DATATYPE_DI:
										iOffset++;
										if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
										{
											SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(float));
											iOffset += sizeof(float);
										}
										else
										{
#ifdef _DEBUG_MSG_
											sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
											DebugPrint(szbuf);
#endif
										}
										break;
									case DATATYPE_STRING:
										iOffset++;
										// ݳ(ռֽ)
										// ֵ
										if((iOffset + userdata->MsgData[iOffset] + 1) < MAX_RTU_MSG_SIZE)
										{
											iOffset += userdata->MsgData[iOffset] + 1;
										}
										else
										{
#ifdef _DEBUG_MSG_
											sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
											DebugPrint(szbuf);
#endif
										}
										break;
									default:
										userdata->MsgLen = 0;
										return;
								}
								break;
							case ITEM_ATTR_UNIT://   
							case ITEM_ATTR_DESCRIPTION://   
								// ݳ(ռֽ)
								//userdata->MsgData[iOffset];
								// ֵ
								if((iOffset + userdata->MsgData[iOffset] + 1) < MAX_RTU_MSG_SIZE)
								{
									iOffset += userdata->MsgData[iOffset] + 1;
								}
								else
								{
#ifdef _DEBUG_MSG_
									sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
									DebugPrint(szbuf);
#endif
								}

								break;
							case ITEM_ATTR_RATE://   
							case ITEM_ATTR_LIST://   
							default:
								iOffset = uDataLen;
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "жȡֵĸʽдЧ");
								DebugPrint(szbuf);
#endif
								break;
						}
					}
					break;
				case hPAIDATAWITHNO:			// ģݴ
					break;
				case hPDIDATAWITHNO:			// ݴ
					break;
				case hFIXDATA:// ֵ
					// ֵ
					datatype = userdata->MsgData[iOffset++];

					// ʼ
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
					}

					for(;iOffset<uDataLen;)
					{
						switch(datatype)
						{
							case ITEM_ATTR_REALVALUE:// ʵֵ
							case ITEM_ATTR_DEFAULTVALUE:// ȱʡֵ
							case ITEM_ATTR_MINMAXSTEP://   
							case ITEM_ATTR_PRECISION://   
							case ITEM_ATTR_FIGURE://   
								// ֵ
								switch(userdata->MsgData[iOffset] & 0x7F)
								{
									case DATATYPE_AI:
									case DATATYPE_DI:
										iOffset++;
										// ֵ										
										if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
										{
											SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(float));
											iOffset += sizeof(float);
										}
										else
										{
#ifdef _DEBUG_MSG_
											sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
											DebugPrint(szbuf);
#endif
										}

										break;
									case DATATYPE_STRING:
										iOffset++;
										// ݳ(ռֽ)
										// ֵ
										if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
										{
											iOffset += userdata->MsgData[iOffset] + 1;
										}
										else
										{
#ifdef _DEBUG_MSG_
											sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
											DebugPrint(szbuf);
#endif
										}

										break;
									default:
										userdata->MsgLen = 0;
										return;
								}
								break;
							case ITEM_ATTR_UNIT://   
							case ITEM_ATTR_DESCRIPTION://   
								// ݳ(ռֽ)								
								// ֵ
								if((iOffset + userdata->MsgData[iOffset] + 1) < MAX_RTU_MSG_SIZE)
								{
									iOffset += userdata->MsgData[iOffset] + 1;
								}
								else
								{
#ifdef _DEBUG_MSG_
									sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
									DebugPrint(szbuf);
#endif
								}

								break;
							case ITEM_ATTR_RATE://   
							case ITEM_ATTR_LIST://   
							default:
								iOffset = uDataLen;
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "жȡֵĸʽдЧ");
								DebugPrint(szbuf);
#endif
								break;
						}
					}
					break;
				case hREADDATAEND:// 
					break;
				case hNORESPONSE:// Ӧ
					break;
				case hSYSTEMBUSY:// ݴæԺ
					break;
				case hFIXNODATA:// ֵ
					break;
				case hPAIDATA:// ģ
					// ģ
					datatype = userdata->MsgData[iOffset++];

					// ʼ
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					for(;iOffset<uDataLen;)
					{				
						switch(datatype)
						{
							case ITEM_ATTR_REALVALUE:// ʵֵ
							case ITEM_ATTR_DEFAULTVALUE:// ȱʡֵ
							case ITEM_ATTR_MINMAXSTEP://   
							case ITEM_ATTR_PRECISION://   
							case ITEM_ATTR_FIGURE://    
								// ֵ
								if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
								{
									SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(float));
									iOffset += sizeof(float);
								}
								else
								{
#ifdef _DEBUG_MSG_
									sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
									DebugPrint(szbuf);
#endif
									userdata->MsgLen = 0;
								}
								break;
							case ITEM_ATTR_UNIT://   
							case ITEM_ATTR_DESCRIPTION://   
								// ݳ(ռֽ)
								// ֵ
								if((iOffset + userdata->MsgData[iOffset] + 1) < MAX_RTU_MSG_SIZE)
								{
									iOffset += userdata->MsgData[iOffset] + 1;
								}
								else
								{
#ifdef _DEBUG_MSG_
									sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
									DebugPrint(szbuf);
#endif
									userdata->MsgLen = 0;
								}
								break;
							case ITEM_ATTR_RATE://   
							case ITEM_ATTR_LIST://   
							default:
								iOffset = uDataLen;
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "жȡģĸʽдЧ");
								DebugPrint(szbuf);
#endif
								userdata->MsgLen = 0;
								break;
						}
					}
					break;
				case hPDIDATA:// 
					// 
					datatype = userdata->MsgData[iOffset++];

					// ʼ
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					for(; iOffset<uDataLen;)
					{
						switch(datatype)
						{
							case ITEM_ATTR_REALVALUE:// ʵֵ
							case ITEM_ATTR_DEFAULTVALUE:// ȱʡֵ					
								// ֵ
								iOffset++;
								break;
							case ITEM_ATTR_UNIT://   
							case ITEM_ATTR_DESCRIPTION://   
								// ݳ(ռֽ)
								// ֵ
								if((iOffset + userdata->MsgData[iOffset] + 1) < MAX_RTU_MSG_SIZE)
								{
									iOffset += userdata->MsgData[iOffset] + 1;
								}
								else
								{
									userdata->MsgLen = 0;
								}
								break;
							case ITEM_ATTR_MINMAXSTEP://   
							case ITEM_ATTR_PRECISION://   
							case ITEM_ATTR_FIGURE://    
							case ITEM_ATTR_RATE://   
							case ITEM_ATTR_LIST://   
							default:
								iOffset = uDataLen;
#ifdef _DEBUG_MSG_
								sprintf(szbuf, "жȡĸʽдЧ");
								DebugPrint(szbuf);
#endif
								userdata->MsgLen = 0;
								break;
						}
					}
					break;
				case hPWAVEDATASTART:// Ϳʼ
					break;
				case hPWAVEDATA:// 
					/*
					//ʼ
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//					
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(WORD));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(WORD));
						iOffset += sizeof(WORD);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//תʱ
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE) 
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת΢
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));						
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}
					//ʱ
					if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(float));
						iOffset += sizeof(float);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					for(;iOffset<uDataLen;)
					{
						//ֵ
						if((iOffset + sizeof(float)) < MAX_RTU_MSG_SIZE)
						{
							SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(float));
							iOffset += sizeof(float);
						}
						else
						{
#ifdef _DEBUG_MSG_
							sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
							DebugPrint(szbuf);
#endif
							userdata->MsgLen = 0;
							break;
						}

					}
					*/
					break;
				case hPWAVEDATAEND:// ͽ
					break;
				case hPEVENTDATAWITHID:// ŵ¼
					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//תʱ
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת
					if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
						iOffset += sizeof(u_short);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					//ת΢
					if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
					{
						SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
						iOffset += sizeof(u_32);
					}
					else
					{
#ifdef _DEBUG_MSG_
						sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
						DebugPrint(szbuf);
#endif
						userdata->MsgLen = 0;
						break;
					}

					for(;iOffset<uDataLen;)
					{
						//ת
						if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
						{
							SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
							iOffset += sizeof(u_short);
						}
						else
						{
#ifdef _DEBUG_MSG_
							sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
							DebugPrint(szbuf);
#endif
							userdata->MsgLen = 0;
							break;
						}

						//ע
						if(userdata->MsgData[iOffset] > 0)
						{
							iOffset += userdata->MsgData[iOffset]+1;
						}
						else
						{
							iOffset++;
						}
					}
					break;
				case hPEVENTDATAWITHSTRING:// ַ¼
					for(; iOffset<uDataLen;)
					{
						//תַ
						u_shortLen = *(u_short*)&userdata->MsgData[iOffset];
						if((iOffset + sizeof(u_short)) < MAX_RTU_MSG_SIZE)
						{
							SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_short));
							iOffset += sizeof(u_short);
						}
						else
						{
#ifdef _DEBUG_MSG_
							sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
							DebugPrint(szbuf);
#endif
							userdata->MsgLen = 0;
							break;
						}
						//ַ
						if((iOffset + u_shortLen) < MAX_RTU_MSG_SIZE)
						{
							iOffset += u_shortLen;
						}
						else
						{
#ifdef _DEBUG_MSG_
							sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset + u_shortLen);
							DebugPrint(szbuf);
#endif
							userdata->MsgLen = 0;
							break;
						}
					}
					break;
				case hWRITEFIXACK:// ֵȷ
					break;
				case hWRITEFIXNAK:// ֵȷ
					break;
				case hWRITEFIXNOACK:// ֵ޸ȷ
					break;
				case hWRITEFIXNONAK:// ֵ޸Ĳȷ
					break;
			}
			break;
		case fPFV_NETACTIVE://԰
			break;
		case fPFV_STATUS://ǰû״̬
			iOffset = 0;
			//ǰûA״̬
			if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
			{
				SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
				iOffset += sizeof(u_32);
			}
			else
			{
#ifdef _DEBUG_MSG_
				sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
				DebugPrint(szbuf);
#endif
				userdata->MsgLen = 0;
				break;
			}

			//ǰûB״̬
			if((iOffset + sizeof(u_32)) < MAX_RTU_MSG_SIZE)
			{
				SequenceHostToNet((char *)&userdata->MsgData[iOffset], sizeof(u_32));
				iOffset += sizeof(u_32);
			}
			else
			{
#ifdef _DEBUG_MSG_
				sprintf(szbuf, "AllHostToNetByteSequenceڴ濽ȣ%dΧ, ڴδ", iOffset);
				DebugPrint(szbuf);
#endif
				userdata->MsgLen = 0;
				break;
			}
			break;

		default:
			break;
	}
}

void ScadaProtectProcessData(int commid, SCADAPROTECTPORTPARAM *psPortParam, BOOL bProcess)
{
	PROTECTMSG				msg;
	SCADAPROTECTPORTPARAM	*pPortParam;
	
	/*
	if(FALSE == GetPortParamPtr(commid, &pPortParam))
	{
		return;
	}
	*/
	pPortParam = psPortParam;

	if(TRUE == bProcess)
	{
		memcpy((void *)&msg, psPortParam->m_achRecvBuf+6, pPortParam->m_iRecvLen-6);
		AllNetToHostByteSequence(&msg);
		
		// վݴ
		if(PROTOCOL_MASTER == pPortParam->m_psBaoHu->PortType)
		{
			return;
		}

		// վݴ
		switch(msg.MsgType)
		{
			case pPFV_PROTECT_BYPASS:// ָ
				ScadaProtectByPassData(commid, pPortParam, &msg);
				break;
			case fPFV_PROTECT_BYPASS_ACK:	// бݴ
				break;
			case fPFV_NETACTIVE:// 
				break;
			default:
				break;
		}
	}
}

void ReduceTimeOut(SCADAPROTECTPORTPARAM *psPortParam)
{
	int		i, iMaxPort;

	if(psPortParam->m_pPrtPortStatus == NULL)
	{
		return;
	}

	iMaxPort = GetMaxPort();
	for(i=0; i<iMaxPort; i++)
	{
		if(psPortParam->m_pPrtPortStatus[i].timeOut > 0)
		{
			psPortParam->m_pPrtPortStatus[i].timeOut--;

			if(psPortParam->m_pPrtPortStatus[i].timeOut <= 0)
			{
				psPortParam->m_pPrtPortStatus[i].mmid = 0xFFFFFFFF;
				psPortParam->m_pPrtPortStatus[i].bPortIdle = TRUE;
			}
		}
	}	
}

BOOL IsProtectPortIdle(int commid, SCADAPROTECTPORTPARAM *psPortParam)
{
	if((commid < 0) || (commid > GetMaxPort()))
	{
		return TRUE;
	}

	if(psPortParam->m_pPrtPortStatus == NULL)
	{
		return TRUE;
	}
	
	return psPortParam->m_pPrtPortStatus[commid].bPortIdle;
}

BOOL GetProtectPortIdle(int commid, SCADAPROTECTPORTPARAM *psPortParam, PORTSTATUS *pStatus)
{
	if((commid < 0) || (commid > GetMaxPort()))
	{
		return FALSE;
	}

	if(psPortParam->m_pPrtPortStatus == NULL)
	{
		return FALSE;
	}

	pStatus->mmid = psPortParam->m_pPrtPortStatus[commid].mmid;
	pStatus->timeOut = psPortParam->m_pPrtPortStatus[commid].timeOut;
	pStatus->bPortIdle = psPortParam->m_pPrtPortStatus[commid].bPortIdle;

	return TRUE;
}

BOOL SetProtectPortIdle(int commid, SCADAPROTECTPORTPARAM *psPortParam, PORTSTATUS *pStatus)
{
	if((commid < 0) || (commid > GetMaxPort()))
	{
		return FALSE;
	}

	if(psPortParam->m_pPrtPortStatus == NULL)
	{
		return FALSE;
	}

	// wen 2005.06.22 uclinuxϵͳ,ʼʱȫΪ0
	/*
	if(psPortParam->m_pPrtPortStatus[commid].bPortIdle == FALSE)
	{
		if(psPortParam->m_pPrtPortStatus[commid].mmid != pStatus->mmid)
		{
			return FALSE;
		}
	}

	psPortParam->m_pPrtPortStatus[commid].bPortIdle = pStatus->bPortIdle;
	psPortParam->m_pPrtPortStatus[commid].mmid = pStatus->mmid;
	psPortParam->m_pPrtPortStatus[commid].timeOut = pStatus->timeOut;
	*/

	//printf("Idle1(port%d): Idle=%d, mmid=%d, timeout=%d\n", commid+1,
	//	pStatus->bPortIdle, pStatus->mmid, pStatus->timeOut);

	psPortParam->m_pPrtPortStatus[commid].bPortIdle = pStatus->bPortIdle;
	psPortParam->m_pPrtPortStatus[commid].mmid = pStatus->mmid;
	psPortParam->m_pPrtPortStatus[commid].timeOut = pStatus->timeOut;

	//printf("Idle2(port%d): Idle=%d, mmid=%d, timeout=%d\n", commid+1,
	//	psPortParam->m_pPrtPortStatus[commid].bPortIdle,
	//	psPortParam->m_pPrtPortStatus[commid].mmid,
	//	psPortParam->m_pPrtPortStatus[commid].timeOut);	

	return TRUE;
}

BOOL SetProtectPortIdleEx(int commid, int iBaoHuCommid, PORTSTATUS *pStatus)
{
	SCADAPROTECTPORTPARAM *pPortParam;

	if((iBaoHuCommid < 0) || (iBaoHuCommid > GetMaxPort()))
	{
		return FALSE;
	}

	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[iBaoHuCommid].ExtInfo;

	if(pPortParam->m_pPrtPortStatus == NULL)
	{
		return FALSE;
	}

	if((commid < 0) || (commid > GetMaxPort()))
	{
		return FALSE;
	}

	//printf("Idle1(port%d): Idle=%d, mmid=%d, timeout=%d\n", commid+1,
	//	pStatus->bPortIdle, pStatus->mmid, pStatus->timeOut);

	pPortParam->m_pPrtPortStatus[commid].bPortIdle = pStatus->bPortIdle;
	pPortParam->m_pPrtPortStatus[commid].mmid = pStatus->mmid;
	pPortParam->m_pPrtPortStatus[commid].timeOut = pStatus->timeOut;

	//printf("Idle2(port%d): Idle=%d, mmid=%d, timeout=%d\n", commid+1,
	//	pPortParam->m_pPrtPortStatus[commid].bPortIdle,
	//	pPortParam->m_pPrtPortStatus[commid].mmid,
	//	pPortParam->m_pPrtPortStatus[commid].timeOut);	

	return TRUE;
}

void SendResponsetoMMI(int commid, int mmid, u_32 ResponseType, PROTECTMSG *pmsg)
{
	PROTECTMSG	mmimsg;
	pPROTECTCONTENTHEAD ptrProHead, pSourProHead;

	memset((void*)&mmimsg, 0, sizeof(PROTECTMSG));
	mmimsg.MsgType = fPFV_PROTECT_BYPASS_ACK;
	ptrProHead = (pPROTECTCONTENTHEAD)mmimsg.MsgData;	
	if(pmsg != NULL)
	{
		pSourProHead = (pPROTECTCONTENTHEAD)pmsg->MsgData;
		mmimsg.PortNumber = pmsg->PortNumber;
		
		//memcpy(mmimsg.MsgData, rtumsg->MsgData, 10);
		ptrProHead->cCPUNo = pSourProHead->cCPUNo;
		ptrProHead->cFixNo = pSourProHead->cFixNo;
		ptrProHead->uAddr = pSourProHead->uAddr;
		ptrProHead->uFuncCode = pSourProHead->uFuncCode;
		ptrProHead->ummid = pSourProHead->ummid;
		ptrProHead->uReserved = pSourProHead->uReserved;
	}
			
	switch(ResponseType)
	{
		case hREADINGDATA:	// ݽʼ
		case hREADDATAEND:	// ݽ
		case hSYSTEMBUSY:	// ݽæ
		case hNORESPONSE:	// Ӧ
			// û
			ptrProHead->ummid = mmid;

			// 
			ptrProHead->uFuncCode = ResponseType;
			
			// λ
			mmimsg.MsgLen = sizeof(PROTECTCONTENTHEAD);
			break;
	}

	if(mmimsg.MsgLen > 0)
	{
		// ˿
		//SendDataToPort(commid, (char *)&mmimsg, sizeof(PROTECTMSGHEAD)+mmimsg.MsgLen);
		FormatDataAndSend(commid, &mmimsg);
	}
}

//  103Լʽתscadaڲʽ͵ָĶ˿
BOOL ScadaProtectConvertToScadaFrameAndSend(int commid)
{
	// SendDataToPort(commid, (char *)&mmimsg, sizeof(PROTECTMSGHEAD)+mmimsg.MsgLen);
	return TRUE;
}

//  ת103Լʽ͵ָĶ˿
BOOL ScadaProtectConvertTo103AndSend(int commid, PROTECTMSG *pmsg)
{
	PROTECTCONTENTHEAD		*ptrProHead;

	ptrProHead = (PROTECTCONTENTHEAD *)pmsg->MsgData;

	switch(ptrProHead->uFuncCode)
	{
		// ȡֵ
		case hREADFIX:
			break;

		// ȡֵ
		case hREADFIXNO:
			break;

		// ȡģ
		case hREADPAI:
			break;
		
		// ȡ
		case hREADPDI:
			break;

		// ȡ
		case hREADPWAVE:
			break;

		// ȡָϱ
		case hQUERYFAULT:
			break;

		// ȡָԼ챨
		case hQUERYSELFCHECK:
			break;

		// ޸ıֵ
		case hWRITEALLFIX:
			break;

		// ޸ָıֵ
		case hWRITESPECIALFIX:
			break;
	
		// ֵȷ
		case hWRITEFIXACK:
			break;

		// ֵȷ
		case hWRITEFIXNAK:
			break;

		// ޸ıֵ
		case hWRITEFIXNO:
			break;

		// ֵ޸ȷ
		case hWRITEFIXNOACK:
			break;

		// ֵ޸Ĳȷ
		case hWRITEFIXNONAK:
			break;

		// źŸ
		case hRESETPROTECT:
			break;

		// װöʱ
		case hCHECKTIME:
			break;
			
		// װù㲥ʱ
		case hBROADCASTCHECKTIME:
			break;

		// ȡ
		case hCANCEL:
			break;
	}

	return TRUE;
}

void ScadaProtectByPassData(int commid, SCADAPROTECTPORTPARAM *psPortParam, PROTECTMSG *pmsg)
{
	int						mmid, port;
	RTUMSG					rtumsg;
	PORTSTATUS				sPortStatus;
	PROTECTCONTENTHEAD		*ptrProHead;
	SCADAPROTECTPORTPARAM	*pPortParam;

	pPortParam = psPortParam;

	ptrProHead = (PROTECTCONTENTHEAD *)pmsg->MsgData;

	port = pmsg->PortNumber;
	mmid = 0;

	if(ptrProHead->uFuncCode == hCANCEL)
	{
		SendResponsetoMMI(commid, mmid, hREADDATAEND, pmsg);
		sPortStatus.bPortIdle = TRUE;
		sPortStatus.mmid = 0xFFFFFFFF;
		sPortStatus.timeOut = 0;
		SetProtectPortIdle(port, pPortParam, &sPortStatus);
		return;
	}

	if(GetProtectPortIdle(port, pPortParam, &sPortStatus) == FALSE)
	{
		return;
	}

	// wen 2005.06.22 Debug
	//DispPrtPortStatus(commid, pPortParam);

	if(sPortStatus.bPortIdle == FALSE)
	{
		// ݽæ
		SendResponsetoMMI(commid, mmid, hSYSTEMBUSY, pmsg);
		return;
	}
	
	if((sPortStatus.mmid != 0xffffffff)
		&& (mmid != (int)sPortStatus.mmid))
	{
		// ݽæ
		SendResponsetoMMI(commid, mmid, hSYSTEMBUSY, pmsg);
		return;
	}

	rtumsg.MsgLen = sizeof(PROTECTMSGHEAD)+pmsg->MsgLen;
	rtumsg.PortIdx = commid;
	rtumsg.MsgType = MSGTYPE_BAOHU_SCADACMD;
	memcpy(rtumsg.MsgData, (void *)pmsg, rtumsg.MsgLen);
	//PutBaohuDataToPort(&rtumsg);

	SendProtectCmdToDev(port, &rtumsg);

	sPortStatus.bPortIdle = FALSE;
	sPortStatus.mmid = mmid;
	sPortStatus.timeOut = OPERPROTECTTIMEOUT*1000/TIMER_CNT;
	SetProtectPortIdle(port, pPortParam, &sPortStatus);
}

BOOL FormatDataAndSend(int commid, PROTECTMSG *pmsg)
{
	int		iDataLen;
	char	buf[4096];

	iDataLen = 6+sizeof(PROTECTMSGHEAD)+pmsg->MsgLen;
	if(iDataLen > sizeof(buf))
	{
		return FALSE;
	}

	AllHostToNetByteSequence(pmsg);

	memcpy(buf, SyncWordEB, 6);
	memcpy(buf+6, (void *)pmsg, iDataLen-6);
	SendDataToPort(commid, buf, iDataLen);

	return TRUE;
}

void MakeInteractionCmd(int commid, int sourcommid, u_32 ResponseFunc, PROTECTCONTENTHEAD *pSourHead, BOOL bBoardCast)
{
	PROTECTMSG			msg;	
	pPROTECTCONTENTHEAD	ptrProHead;	
#ifdef _DEBUG_MSG_
	char	szbuf[256];
#endif

	msg.MsgLen = 0;
	memset((void*)&msg, 0, sizeof(PROTECTMSG));
	msg.MsgType = fPFV_PROTECT_BYPASS_ACK;
	msg.PortNumber = sourcommid;
	
	ptrProHead = (pPROTECTCONTENTHEAD)msg.MsgData;
	// 㲥
	if(bBoardCast == TRUE)
	{
		ptrProHead->ummid = 0xffffffff;
	}

	ptrProHead->uFuncCode = ResponseFunc;
	ptrProHead->uAddr = pSourHead->uAddr;
	ptrProHead->ummid = pSourHead->ummid;
	ptrProHead->cCPUNo = pSourHead->cCPUNo;
	ptrProHead->cFixNo = pSourHead->cFixNo;
	ptrProHead->uReserved = 0;

	switch(ResponseFunc)
	{
		case hREADINGDATA:				// 
		case hPWAVEDATASTART:			// Ϳʼ
		case hREADDATAEND:				// 
		case hPWAVEDATAEND:				// ͽ
		case hWRITEFIXNAK:				// ֵȷ
		case hWRITEFIXNONAK:			// ֵ޸Ĳȷ
		case hNORESPONSE:				// Ӧ
			msg.MsgLen = sizeof(PROTECTCONTENTHEAD);
			break;
		default:
#ifdef _DEBUG_MSG_
			sprintf(szbuf, "˿%d ӦЧĹ=%d!!!\n", commid, ResponseFunc);
			DebugPrint(szbuf);
#endif
			break;
	}

	if(msg.MsgLen > 0)
	{
		// ˿
		//SendDataToPort(commid, (char *)&msg, sizeof(PROTECTMSGHEAD)+msg.MsgLen);
		FormatDataAndSend(commid, &msg);
	}
}

void MakeNetActivePacket(int commid)
{
	PROTECTMSG		msg;

	msg.PortNumber = commid;
	msg.MsgType = fPFV_NETACTIVE;
	msg.MsgLen = 0;

	//SendDataToPort(commid, (char *)&msg, sizeof(PROTECTMSGHEAD)+msg.MsgLen);
	FormatDataAndSend(commid, &msg);
}

void MakeStatusPacket(int commid)
{
	u_32			*puData;
	PROTECTMSG		msg;

	msg.PortNumber = commid;
	msg.MsgType = fPFV_STATUS;
	puData = (u_32 *)msg.MsgData;

	*puData = 1;
	//SequenceHostToNet((char *)puData, sizeof(u_32));
	*(puData+1) = 0;
	//SequenceHostToNet((char *)(puData+1), sizeof(u_32));
	msg.MsgLen = sizeof(u_32) * 2;

	//SendDataToPort(commid, (char *)&msg, sizeof(PROTECTMSGHEAD)+msg.MsgLen);
	FormatDataAndSend(commid, &msg);
}

BOOL MakeSoeDataPacket(int commid)
{
	WORD			*pwValue;
	u_32			*puValue;
	int				iDevNo, iOffset;
	SOE_DEF			sSoeData;
	char			szExtend[128];
	PROTECTMSG		msg;
	PROTECTCONTENTHEAD		*pProHead;	
	SCADAPROTECTPORTPARAM	*pPortParam;
	
	pPortParam = (SCADAPROTECTPORTPARAM *)SioParam[commid].ExtInfo;

	msg.MsgType = fPFV_PROTECT_BYPASS_ACK;

	ProvAndDelGetSoeData(commid, &sSoeData);

	iDevNo = FindProtectDevFromPntNoScada(pPortParam, sSoeData.iPntNo, DI_PNT_TYPE);

	// Debug
	//printf("commid=%d sSoeData.iPntNo=%d, iDevNo=%d\n", commid, sSoeData.iPntNo, iDevNo);

	if(iDevNo >= 0)
	{
		msg.PortNumber = pPortParam->m_psProvDev[iDevNo].m_iRealCommid-1;
		pProHead = (PROTECTCONTENTHEAD *)msg.MsgData;
		pProHead->ummid = 0xFFFFFFFF;
		pProHead->uAddr = pPortParam->m_psProvDev[iDevNo].m_iProvAddr;
		pProHead->cCPUNo = (char)0xFF;
		pProHead->cFixNo = (char)0xFF;
		pProHead->uFuncCode = hPEVENTDATAWITHID;
		pProHead->uReserved = 0;
		iOffset = sizeof(PROTECTCONTENTHEAD);
		pwValue = (WORD *)&msg.MsgData[iOffset];
		*pwValue = sSoeData.SoeTime.Year;
		*(pwValue+1) = sSoeData.SoeTime.Month;
		*(pwValue+2) = sSoeData.SoeTime.Day;
		*(pwValue+3) = sSoeData.SoeTime.Hour;
		*(pwValue+4) = sSoeData.SoeTime.Min;
		*(pwValue+5) = sSoeData.SoeTime.Sec;
		iOffset += sizeof(WORD)*6;
		puValue = (u_32 *)&msg.MsgData[iOffset];
		*puValue = sSoeData.SoeTime.mSec;
		iOffset += sizeof(u_32);
		pwValue = (WORD *)&msg.MsgData[iOffset];
		// ޸Ϊfuninf
		//*pwValue = sSoeData.iPntNo - pPortParam->m_psProvDev[iDevNo].m_sYxInfo.m_iStartPntNo + 1;
		*pwValue = (WORD)(((sSoeData.u8ProvFun<<8) + sSoeData.u8ProvInf) & 0x0000FFFF);
		if((*pwValue) == 0)
		{
			*pwValue = sSoeData.iPntNo - pPortParam->m_psProvDev[iDevNo].m_sYxInfo.m_iStartPntNo + 1;
		}

		iOffset += sizeof(WORD);
		
		// <<< ޸
		// йźʱ
		//if(sSoeData.u8Type == 2)
		//{
		//	sprintf(szExtend, "<ʱ[%d],[%d]>", sSoeData.wRelativeTime, sSoeData.wFaultNo);
		//	msg.MsgData[iOffset] = strlen(szExtend);
		//	memcpy((void *)&msg.MsgData[iOffset+1], szExtend, msg.MsgData[iOffset]);
		//	iOffset += msg.MsgData[iOffset]+1;
		//}
		//else
		//{
		//	msg.MsgData[iOffset++] = 0;
		//}

		if(sSoeData.bStatus == 1)
		{
			strcpy(szExtend, "");
		}
		else
		{
			strcpy(szExtend, "ָ");
		}

		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// wen 2005.10.25 ַ¼еĹϲ
		// йźʱ
		//if(sSoeData.u8Type == 2)
		//{
		//	sprintf(szExtend, "%s <ʱ[%d],[%d]>", szExtend, sSoeData.wRelativeTime, sSoeData.wFaultNo);
		//}
		if(sSoeData.u8Type == 2)
		{
			sprintf(szExtend, "%s <ʱ[%d],[%d]>", szExtend, sSoeData.wRelativeTime, sSoeData.wFaultNo);
		}
		else if(sSoeData.u8Type == 3)
		{
			sprintf(szExtend, "%s <%s>", szExtend, sSoeData.szMsgEx);
		}
		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		msg.MsgData[iOffset] = strlen(szExtend);
		memcpy((void *)&msg.MsgData[iOffset+1], szExtend, msg.MsgData[iOffset]);
		iOffset += msg.MsgData[iOffset]+1;
		// >>> 

		msg.MsgLen = iOffset;
		FormatDataAndSend(commid, &msg);
		//soe
		return TRUE;
	}

	return FALSE;
}
//===========================ݴ=========================

//===========================Ժʼ=========================
void DispPrtPortStatus(int commid, SCADAPROTECTPORTPARAM *psPortParam)
{
	int		i, iMaxPort;
	char	szDbg[128];

	iMaxPort = GetMaxPort();
	sprintf(szDbg, ">>>commid=%d, MaxPort=%d, PrtPortStatus:", commid, iMaxPort);
	DebugPrint(szDbg);
	for(i=0; i<iMaxPort; i++)
	{
		sprintf(szDbg, "   port=%d, Idle=%d, mmid=%d, timeout=%d",
			i+1, psPortParam->m_pPrtPortStatus[i].bPortIdle, 
			psPortParam->m_pPrtPortStatus[i].mmid,
			psPortParam->m_pPrtPortStatus[i].timeOut);
		DebugPrint(szDbg);
	}
	strcpy(szDbg, "<<<PrtPortStatus Disp over\n");
	DebugPrint(szDbg);
}
//===========================Ժ=========================